/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.explorer.page.QueryEditor"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$
dojo.require("jazz.core.loader"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox");  //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button");  //$NON-NLS-1$
dojo.require("jazz.ui.Tree"); //$NON-NLS-1$
dojo.require("jazz.ui.tree.IconItem"); //$NON-NLS-1$
dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$
dojo.require("jazz.app.ua.TextHoverHelp"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("dijit._Container"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.layout._LayoutWidget"); //$NON-NLS-1$
dojo.require("dijit.layout.BorderContainer"); //$NON-NLS-1$
dojo.require("dojox.layout.ExpandoPane"); //$NON-NLS-1$
dojo.require("dijit.form.TextBox"); //$NON-NLS-1$
dojo.require("dijit.form.CheckBox"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.ExplorerClient"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.queryparams.ParameterTable"); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Drawer'); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.Section"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.EasyMessageBox");  //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.StatusMessage"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.PrefixSelectionDialog"); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.explorer.queryparams.SystemParameterUtil'); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "ExplorerMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.queryparams", "ParameterTableMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var SystemParameterUtil = com.ibm.relm.explorer.web.explorer.queryparams.SystemParameterUtil;
var SCOPE_PERSONAL = "personal"; //$NON-NLS-1$
var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var JazzUIWorkbench = PlatformUI.getWorkbench();
var PageHoverHelp = jazz.app.ua.PageHoverHelp;
var commonUtil = com.ibm.relm.common.web.ui.util;
//var session = com.ibm.team.repository.web.client.session;
var ServiceResponseHandler = com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler;
var ExplorerClient = com.ibm.relm.explorer.web.explorer.page.ExplorerClient;
var ParameterTable = com.ibm.relm.explorer.web.explorer.queryparams.ParameterTable;
//Format: $prettyName$
var PARAMETER_REG_EX = /\$[^$ ]+\$/g;

var orionEditor = null, globalSetText = null;

dojo.declare("com.ibm.relm.explorer.web.explorer.page.QueryEditor",  //$NON-NLS-1$
	[dijit.layout._LayoutWidget, dijit._Templated],
{
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/page/templates/QueryEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
//    queryText: "",
	_qInfo: {
		queryUri: "", //$NON-NLS-1$
		queryName: "", //$NON-NLS-1$
		description: "", //$NON-NLS-1$
		owner: "", //$NON-NLS-1$
		scope: SCOPE_PERSONAL,
		sparql: "" //$NON-NLS-1$		
	},
	permissions: {},
	eTag: null,
	queryPage: null,

	constructor: function(args) {
		this._mode = args.mode;

		this.nameId = dijit.getUniqueId('relm-QueryEditor'); //$NON-NLS-1$
		this.descriptionId = dijit.getUniqueId('relm-QueryEditor'); //$NON-NLS-1$
		this.sparqlId = dijit.getUniqueId('relm-QueryEditor'); //$NON-NLS-1$
		this.statusId = dijit.getUniqueId('relm-QueryEditorStatus'); //$NON-NLS-1$
		this.folderFieldId = dijit.getUniqueId('relm-QueryEditor'); //$NON-NLS-1$
		
		// Instantiate the SPARQL plugin for Orion by loading it asynchronously
		jazz.core.loader.load_async("com.ibm.relm.explorer.web.ui.internal.orion.SparqlPlugin", dojo.hitch(this,function(){ //$NON-NLS-1$
			orionEditor = null;
			
			new com.ibm.relm.explorer.web.ui.internal.orion.SparqlPlugin();
	        this.initOrionEditor();
	    }));
	},
	
    postMixInProperties: function(){
		this.inherited(arguments);
    	this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryEditorMessages");  //$NON-NLS-1$ //$NON-NLS-2$   	
		this.errorMessages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "ExplorerMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._queryMessages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._parameterTableMessages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.queryparams", "ParameterTableMessages"); //$NON-NLS-1$ //$NON-NLS-2$
    },
	
	postCreate: function(){
		
		/* Declare get and set methods to support Orion Editor */
		this.queryText.get = function(property) {
			if(orionEditor === null) //$NON-NLS-1$
				return ""; //$NON-NLS-1$
			else
				return orionEditor.getText();
		};
		
		this.queryText.set = function(property,value) {
			if(orionEditor === null) //$NON-NLS-1$
				globalSetText = value;
			else {
				setTimeout(function() { // Defer setting of text to allow DOM to load completely
					orionEditor.setText(value);
					orionEditor.getUndoStack().reset();
				},100);
			}
		};
		
		this.inherited(arguments);
		this._widgetsToDestroy= [];
		
		if(this.mode == "create") { //$NON-NLS-1$
			this.saveAsButton.disabled = "true"; //$NON-NLS-1$
			this.saveButton.firstChild.nodeValue = this._messages.CreateQuery;
		} 
		
		this.nameNode.set("value", ""); //$NON-NLS-1$ //$NON-NLS-2$
		this.descriptionText.set("value", ""); //$NON-NLS-1$ //$NON-NLS-2$
		this.queryText.set("value", ""); //$NON-NLS-1$ //$NON-NLS-2$

		this.connect(this.nameNode, "onKeyUp",  "onContentChange"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.descriptionText, "onKeyUp",  "onContentChange"); //$NON-NLS-1$ //$NON-NLS-2$
		//this.connect(this.queryText, "onKeyUp", "onContentChange"); //$NON-NLS-1$ //$NON-NLS-2$

		if (!this.navigateAwayHandle) {
			this.navigateAwayHandle = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigateAway), /*priority*/ 10000);
		}
		if (!this.onBeforeUnloadHandle) {
			this.onBeforeUnloadHandle = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this._handleOnBeforeUnload), /*priority*/ 10000);
		}
		this._createContextSensitiveHelp();

		this._drawer.setDrawerContent(this._paramPane);
		this._initializeParamTable();
		this._initPrefixSelector();
		
		//this.connect(this.queryText, 'onChange', onQueryChange); //$NON-NLS-1$
	},

	initOrionEditor: function() {
		var self = this;
		
		// Instantiate an instance of the Orion Editor and initialize it
		require(["orion/editor/edit", "orion/editor/textMateStyler", "orion/editor/sparqlContentAssist", "orion/editor/sparqlGrammar"], function(edit, mTextMateStyler, mSPARQLContentAssist, mSparqlGrammar) { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			
			// Line and column number status bar
			var status = ""; //$NON-NLS-1$
			var statusReporter = function(message, isError) {
				if (isError) {
					status =  "ERROR: " + message; //$NON-NLS-1$
				} else {
					status = message;
				}
				self.queryTextStatus.innerHTML = status;
			};
			
			// Instantiate the editor
			orionEditor = edit({
				parent: self.queryText,
				statusReporter: statusReporter,
				autoPairParentheses: true,
				autoPairBraces: true,
				autoPairSquareBrackets: true,
				autoPairAngleBrackets: true,
				autoPairQuotations: true,
				smartIndentation: true
			});
			
			// Add SPARQL content assist to the editor
			var contentAssist = orionEditor.getContentAssist ? orionEditor.getContentAssist() : orionEditor._contentAssist;
			contentAssist.providers.push(new mSPARQLContentAssist.SPARQLContentAssistProvider());
			
			// Add Grammar based syntax highlighter for SPARQL to the editor
			var syntaxHighlighter = {
				styler: null,
				highlight: function(editor) {
					if (this.styler) {
						this.styler.destroy();
						this.styler = null;
					}
					var textView = editor.getTextView();
					this.styler = new mTextMateStyler.TextMateStyler(textView, mSparqlGrammar.SparqlGrammar());
				}
			};

			syntaxHighlighter.highlight(orionEditor);
			if (globalSetText !== null)
			{
				orionEditor.setText(globalSetText);
				orionEditor.getUndoStack().reset();
				globalSetText = null;
			}
			
			var textView = orionEditor.getTextView();
			textView.addEventListener("KeyUp", dojo.hitch(self,self.onContentChange)); //$NON-NLS-1$
			textView.addEventListener("ModelChanged", dojo.hitch(self,self.onQueryChange)); //$NON-NLS-1$
		});
	},
	
	//disable the run button if the query string is empty
	onQueryChange: function(){
		this.queryText.value = orionEditor.getText();
		var value = this.queryText.value;
		if(value!==null && value!==undefined && dojo.trim(value) === ''){ //$NON-NLS-1$
			this.submitButton.disabled = true;
		}
		else{
			this.submitButton.disabled = false;
		}
	},

	_initFolderTree: function() {
		if(this._folderInfo && this._folderInfo._inprogress){
			// another request is underway. 
			// only one session can be done.
			return;
		}
		this._enableSaveButtons(false);

		this._clearFolderTree();
		this._folderInfo._inprogress = true;

		var responseHandler = new ServiceResponseHandler(this, "_addFolders", "_remoteError"); //$NON-NLS-1$//$NON-NLS-2$
		ExplorerClient.getFolderDescriptors(responseHandler, {scope: "personal"}); //$NON-NLS-1$
		ExplorerClient.getFolderDescriptors(responseHandler, {scope: "shared"}); //$NON-NLS-1$
	},

	_initPrefixSelector: function() {
		var addPrefix = dojo.create('a', { //$NON-NLS-1$
			href: '#', //$NON-NLS-1$
			innerHTML: this._messages.AddPrefix,
			title: this._messages.AddPrefixTooltip,
			className: 'relm-Section-link' //$NON-NLS-1$
		});
		this.connect(addPrefix, 'onclick', dojo.hitch(this, function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this._handleAddPrefix();
		}));
		this._sparqlPane.setControls(addPrefix);
	},

	_handleAddPrefix: function() {
		var self = this;
		var prefixDialog = new com.ibm.relm.explorer.web.ui.internal.view.edit.PrefixSelectionDialog({
			okCallback: dojo.hitch(this,this._okPrefixDialogCallback),
			cancelCallback: dojo.hitch(this,this._cancelPrefixDialogCallback)
		});

		self._prefixDialog = new jazz.ui.Dialog({
			contentNode: prefixDialog.domNode,
			primaryTitle: self._messages.AddPredifinedPrefix,
			width: "600px", //$NON-NLS-1$
			isClosable: true
		});
	},

	_okPrefixDialogCallback: function(args)
	{	
		this._prefixDialog.close();
		this._prefixDialog.destroy();
		// refresh sparql
		var sparql = this.queryText.get("value"); //$NON-NLS-1$
		sparql = args.prefixText + sparql;
		this.queryText.set("value", sparql); //$NON-NLS-1$
	},

	_cancelPrefixDialogCallback: function(args)
	{
		this._prefixDialog.close();
		this._prefixDialog.destroyRecursive();
	},

	initPermission: function(){
		jazz.client.xhrGet({
			url: com.ibm.relm.explorer.web.ui.queryServiceUri + "?id=-1" + "&permission=", //$NON-NLS-1$ //$NON-NLS-2$
			preventCache: true,
			handleAs: "json", //$NON-NLS-1$
			load: dojo.hitch(this, function(response, ioArgs){
				this.permissions = com.ibm.relm.explorer.web.ui.internal.util.parsePermission(response);
			}),
			error: dojo.hitch(this, "errorHandler") //$NON-NLS-1$
		});

	},

	_initializeParamTable: function() {
		var refreshButton = new jazz.ui.toolbar.Button({
			title: this._messages.UpdateParametersTooltip,
			imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/refresh16.gif"), //$NON-NLS-1$ //$NON-NLS-2$
			"class": "refrehIcon sectionButton", //$NON-NLS-1$ //$NON-NLS-2$
			onClick: dojo.hitch(this, function(e) { 
				dojo.stopEvent(e);
				this._refreshParameters();
			})
		});
		
		this._paramSection.setControls(refreshButton.domNode);

		this._paramTable = new ParameterTable ({
			columns: [
							{label: this._messages.paramName, width: "25%", sortable: false}, //$NON-NLS-1$
	                        {label: this._messages.Type, width: "35%", sortable: false}, //$NON-NLS-1$
	                        {label: this._messages.Label, width: "35%", sortable: false}], //$NON-NLS-1$
	        trim: jazz.ui.StyledTable.TrimStyles.PRIMARY_HEADLESS,
	        showHover: true
		}, this._tableHolder);
		this._widgetsToDestroy.push(this._paramTable);

		this._paramTableOnChangeHandle = dojo.connect(this._paramTable, 'onChange', dojo.hitch(this, this.onContentChange, true)); //$NON-NLS-1$
	},
	
	/**
	 * Cope with case where the enumerations used in the parameter table can't
	 * be retrieved.
	 */
	_drawErrback: function(errObj) {
		this.messageArea.showErrorObject(errObj, true);
	},

	_refreshParameters: function(parameters) {
		if (!parameters || !parameters.length) 
			parameters = this._parseQueryText();

		dojo.removeClass(this._paramTableArea, "hiddenParamTable"); //$NON-NLS-1$
		if (parameters && parameters.length) {
			this.emptyParamTableMessage.style.display = "none"; //$NON-NLS-1$
	        this._paramTable.draw(parameters, dojo.hitch(this, this._drawErrback));
		} else {
			this._paramTable.draw(parameters, dojo.hitch(this, this._drawErrback));
			this.emptyParamTableMessage.style.display = ""; //$NON-NLS-1$
		}	
	},

	hideParamTable: function() {
		this._paramTable.clearBody();
		dojo.addClass(this._paramTableArea, "hiddenParamTable"); //$NON-NLS-1$
	},

	_parseQueryText: function() {
		var query = this.queryText.get('value'); //$NON-NLS-1$
		var paramsInSparql = query.match(PARAMETER_REG_EX) || [];
		if (!paramsInSparql.length) return [];

		var params = [];
		var uniqueParams = {"system": true}; //$NON-NLS-1$

		dojo.filter(paramsInSparql, function(parameterName) {
			//parameterName is the ugly name, want to check for unique pretty names
			var withoutDelimiters = parameterName.substring(1, parameterName.length-1);
			var prettyName = withoutDelimiters.split(/[;\.]/)[0];
			if (!uniqueParams[prettyName]) {
				uniqueParams[prettyName] = true;
				params.push({name: prettyName});
				return true;
			} else {
				return false;
			}
		});
		
		return params;
	},

	toggleParamPane: function() {
		if (this._drawer.get('collapsed')) //$NON-NLS-1$
			this._drawer.animateExpand();
		else
			this._drawer.animateCollapse();
	},

	_createContextSensitiveHelp: function() {
		dojo.empty(this.csHelpNode);
		this._createCSHWidget("com.ibm.relm.explorer.web.page_Query001"); //$NON-NLS-1$
	},

	_createCSHWidget: function(uaKey) {
		var parms = {};
		parms.uaKey = uaKey;
		var pageHelp = new PageHoverHelp(parms);
		this.csHelpNode.appendChild(pageHelp.domNode);
		this._widgetsToDestroy.push(pageHelp);
	},
	
	_handleNavigateAway: function(url, e) {
		// Allow help links to open in a new window without ado
		if (e && e.target && (e.target.tagName == "A") && (e.target.target == "jazzhelp")) { //$NON-NLS-1$ //$NON-NLS-2$
			return false; // allow navigation
		}
		
		var currentLocation = window.location.href;
		var badLink = currentLocation.substring(0, currentLocation.indexOf("#")+1); //$NON-NLS-1$
		if (url == badLink) {
			return true;
		}
		
		if (this.isDirty()) {
			if (! window.confirm(this._messages.navigateAway + "\n\n" + this._messages.unsavedChanges + "\n\n" + this._messages.okOrCancel)) { //$NON-NLS-1$ //$NON-NLS-2$
				return true; // don't navigate away
			}
		}
		this.destroy();
		
		var createQueryLocation = 'action=com.ibm.relm.explorer.web.showExplorer&mode=create'; //$NON-NLS-1$
		//If we are trying to create a new query while in create mode, then this happens
		if (url.fragment === createQueryLocation && dojo.hash() === createQueryLocation) { //$NON-NLS-1$
			dojo.publish('CREATE_QUERY'); //$NON-NLS-1$
			return false;
		}
		// Remove spell check attribute
		if(dojo.isFF !== undefined)
			dojo.body().removeAttribute("spellCheck"); //$NON-NLS-1$
		return false; // allow navigation
	},
	
	_handleOnBeforeUnload: function() {
		return (this.isDirty()) ? this._messages.unsavedChanges + "\n\n" : false; //$NON-NLS-1$
	},

	destroy: function() {
		// Remove spell check attribute
		if(dojo.isFF !== undefined)
			dojo.body().removeAttribute("spellCheck"); //$NON-NLS-1$
		if(orionEditor !== null)
			orionEditor.destroy();
		if (this.navigateAwayHandle) {
			PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
			this.navigateAwayHandle = null;
		}
		if (this.onBeforeUnloadHandle) {
			PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
			this.onBeforeUnloadHandle = null;
		}
		dojo.forEach(this._widgetsToDestroy, function(w) { w.destroy(); });

		dojo.disconnect(this._paramTableOnChangeHandle);

		this._clearFolderTree(); // destroy _folderTreeWidget

		this.inherited(arguments);
	},

	layout: function(){
    	this._content.resize();
    },
    
	_createFolderTree: function() {
		if(this._folderTreeWidget) {
			this._folderTreeWidget.destroy();
		}
		this._folderTreeWidget = new jazz.ui.Tree();
		// Hardcode this height to force scrollbars if there are too many
		// folders. This height is not a perfect match for the left side,
		// but works OK. Needed since we can't size relative to the table
		// cell we're in.
		this._folderTreeWidget.domNode.style.height = '81px'; //$NON-NLS-1$
		this._folderTree.appendChild(this._folderTreeWidget.domNode);
		this._folderTreeWidget.onSelectionChanged = dojo.hitch(this,this._handleFolderSelectionChange);
	},
	
	_clearFolderTree: function() {
		if(this._folderTreeWidget) {
			this._folderTreeWidget.destroy();
			this._folderTreeWidget = null;
		}
		this._folderInfo = {
			_allFolders: [],
			// A map mapping folder nodes to the underlying folder
			_folderMap: {},
			_responseCount: 0
		};
	},

	_getFoldersFromResult: function(response){

		return dojo.map(response.results.bindings, function(r){
			return { 
				"name": {  //$NON-NLS-1$
					label: r.name.value, 
					type: "uri",  //$NON-NLS-1$
					value: r.uri.value
				}, 
				"description": r.description.value, //$NON-NLS-1$
				"creator": r.creator.value, //$NON-NLS-1$
				"modified": r.modified.value,            			 //$NON-NLS-1$
				"ownedBy": r.ownedBy.value, //$NON-NLS-1$
				"shared" : (r.scope.value == "shared") ? true: false, //$NON-NLS-1$ //$NON-NLS-2$
				"parentUUID": r.parentUuid.value, //$NON-NLS-1$
				"folderUUID": r.folderUUID.value //$NON-NLS-1$
			};
		});
	},

	_addFolders: function(response) {
		var folders = this._getFoldersFromResult(response);
		this._responseCount++;
		if (!folders) folders = [];
		for (var i = 0; i < folders.length; i++) {
			this._folderInfo._allFolders.push(folders[i]);
		}
		if (this._folderInfo._responseCount == 1) {
			// root folder has 2 folders (shared and personal), so wait for the second response.
			return;
		}
		this._folderInfo._inprogress = false;
		this._addFoldersToTree();
	},
	
	_addFoldersToTree: function() {
		this._createFolderTree();
		// First, find the two root folders
		var sharedRoot = null;
		var privateRoot = null;
		dojo.forEach(this._folderInfo._allFolders, function(folder){
			if (!folder.parentUUID) { //$NON-NLS-1$
				if (folder.shared) {
					sharedRoot = folder;
				} else {
					privateRoot = folder;
				}
			}
		});

		if (privateRoot) {
			var rootItem = new jazz.ui.tree.IconItem({label: this._queryMessages.myQueries, iconClass: "iconFolder"}); //$NON-NLS-1$
			privateRoot.treeItemID = rootItem.getId();  //Save the item ID in the folders array in case we need to make tree calls based on the id
			this._folderInfo._folderMap[rootItem] = privateRoot;
			this._folderTreeWidget.addChild(rootItem);
			this._addChildrenForFolder(rootItem, privateRoot, this._folderInfo._allFolders, false, false);
		}
		if (sharedRoot) {
			rootItem = new jazz.ui.tree.IconItem({label: this._queryMessages.sharedQueries, iconClass: "iconFolder"}); //$NON-NLS-1$
			sharedRoot.treeItemID = rootItem.getId();  //Save the item ID in the folders array in case we need to make tree calls based on the id
			this._folderInfo._folderMap[rootItem] = sharedRoot;
			this._folderTreeWidget.addChild(rootItem);
			this._addChildrenForFolder(rootItem, sharedRoot, this._folderInfo._allFolders, false, true);
			this._sharedRootItem = rootItem;
		}
		this._selectFolder(this._qInfo.parentUuid || (this.queryPage._lastQueryList && this.queryPage._lastQueryList._rootUUID));
		this.onContentChange();
	},

	/**
	 * From the list of folders, find any that are children of parentFolder, and
	 * add them to the tree. Then recurse for each of the children.
	 */
	_addChildrenForFolder: function(parentFolderNode, parentFolder, folders, parentIsRoot, parentIsShared) {
		var foldersToAdd = [];
		for (var i = 0; i < folders.length; i++) {
			// Special case where the parent is a root system folder
			if (parentIsRoot) {
				if (!folders[i].parentUUID && (folders[i].shared == parentIsShared) && (folders[i].name.value !== parentFolder.name.value)) {
					foldersToAdd.push(folders[i]);
				}
			} else {
				if (folders[i].parentUUID == parentFolder.folderUUID) {
					folders[i].shared = parentFolder.shared;
					foldersToAdd.push(folders[i]);
				}
			}
		}
		foldersToAdd = foldersToAdd.sort(function(a, b) {return a.name.label > b.name.label;});
		for (var i = 0; i < foldersToAdd.length; i++) {
			var childNode = new jazz.ui.tree.IconItem({label: com.ibm.relm.explorer.web.ui.internal.util.escapeHtml(foldersToAdd[i].name.label), iconClass: "iconFolder"}); //$NON-NLS-1$
			foldersToAdd[i].treeItemID = childNode.getId();  //Save the item ID in the folders array in case we need to make tree calls based on the id
			this._folderInfo._folderMap[childNode] = foldersToAdd[i];
			parentFolderNode.addChild(childNode);
			this._addChildrenForFolder(childNode, foldersToAdd[i], folders, false, parentIsShared);
		}
	},

	_selectFolder: function(folderUUID)
	{
		if(!this._folderTreeWidget){
			return;
		}
		if(!folderUUID
			//temporary work around for workitem 89174, 89302 and 89610. However real solution is to redesign the query editor 
			//so it handles url redirection with the browser navigation buttons appropriately and doesn't lose the query. workitem 82545 
			//PLEASE REMOVE when 82545 is fixed!
			&& this._folderTreeWidget._branches && this._sharedRootItem && this._folderTreeWidget._branches[this._sharedRootItem.getId()]
		){
			// fallback
			this._folderTreeWidget.setSelection(this._sharedRootItem);
			return;
		}
		//Get the itemID from the folder map based on the folder UUID
		//the select that item in the tree
		for (var key in this._folderInfo._folderMap)
		{
			//If the folder in the map is the same as the supplied folder UUID then get the item
			var targetFolder = this._folderInfo._folderMap[key];
			if (targetFolder.folderUUID == folderUUID)
			{
				//Get the item from the tree
				var folderToSelect = this._folderTreeWidget.getItem(targetFolder.treeItemID);
				//Expand the tree down to the folder to select
				var parentItem = folderToSelect.getParent();
				while (parentItem != null) 
				{
					parentItem.setExpanded(true);
					parentItem = parentItem.getParent();
				}
				//select it
				this._folderTreeWidget.setSelection(folderToSelect);
				break;
			}
		}
	},

	setQueryInfo: function(queryInfo) {
		this.initPermission();
		// widget properties
		var qinfo = this._qInfo;
		qinfo.queryUri = queryInfo.queryUri || ""; //$NON-NLS-1$
		qinfo.queryName = queryInfo.queryName || "";  //$NON-NLS-1$
		qinfo.description = queryInfo.description || ""; //$NON-NLS-1$
		qinfo.owner = queryInfo.owner || false;
		qinfo.scope = queryInfo.scope || SCOPE_PERSONAL;
		qinfo.sparql = queryInfo.sparql || ""; //$NON-NLS-1$
		qinfo.parameters = queryInfo.parameters || [];
		qinfo.parameterized = queryInfo.parameterized || ""; //$NON-NLS-1$
		qinfo.parentUuid = queryInfo.parentUuid || ""; //$NON-NLS-1$
		qinfo.isDirty = queryInfo.isDirty || false;
		// set UI values 
		this._initFolderTree();
		this.nameNode.set("value", qinfo.queryName); //$NON-NLS-1$
		this.descriptionText.set("value", qinfo.description); //$NON-NLS-1$
		this.queryText.set("value", qinfo.sparql); //$NON-NLS-1$
		this._setParameters(qinfo.parameters);
		if (!(qinfo.parameters && qinfo.parameters.length > 0)) {
			this.hideParamTable();
		}

		if(queryInfo.queryUri){
			var message = com.ibm.relm.common.web.StatusMessage.show(this._queryMessages.loading);
			var self = this;
			
	        jazz.client.xhrGet({
	            url: queryInfo.queryUri,
				preventCache: true,
				headers: {"Accept":"text/json"},  //$NON-NLS-1$ //$NON-NLS-2$
	            handleAs: "json", //$NON-NLS-1$
	            preventCache: true,
	            
				handle: function() {
					message.hide();
				},
	            
	            load: function(data, ioArgs){
	            	// keep eTag for update/delete
	            	self.eTag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
	            	
	            	// get query content
	            	var queryData = data[""]; //$NON-NLS-1$
	            	var namespaces = com.ibm.relm.explorer.web.ui.namespace;
	            	var titles = queryData[namespaces.dcterms.title];
	            	var descriptions = queryData[namespaces.dcterms.description];
	            	var owners = queryData[namespaces.query.ownedBy];
	            	var scopes = queryData[namespaces.query.scope];
	            	var sparqls = queryData[namespaces.query.sparql];
	            	var parentUuid = queryData[namespaces.query.parentUuid];
	            	var parameterized = queryData[namespaces.query.parameterized];

	        		// keep original query properties
	            	qinfo.queryName = (titles && titles.length > 0 && titles[0].value) || ""; //$NON-NLS-1$
	            	qinfo.description = (descriptions && descriptions.length > 0 && descriptions[0].value) || ""; //$NON-NLS-1$
	            	qinfo.owner = (owners && owners.length > 0 && owners[0].value) || ""; //$NON-NLS-1$
	            	qinfo.scope = (scopes && scopes.length > 0 && scopes[0].value) || SCOPE_PERSONAL;
	            	qinfo.sparql = (sparqls && sparqls.length > 0 && sparqls[0].value) || ""; //$NON-NLS-1$
	            	qinfo.parentUuid = (parentUuid && parentUuid.length > 0 && parentUuid[0].value) || ""; //$NON-NLS-1$
	            	qinfo.parameterized = (parameterized && parameterized.length > 0 && parameterized[0].value) || ""; //$NON-NLS-1$   	

					// set UI values
	            	if(!queryInfo.sparql){
						self.queryText.set("value", qinfo.sparql);  //$NON-NLS-1$ 
						self.nameNode.set("value", qinfo.queryName); //$NON-NLS-1$
						self.descriptionText.set("value", qinfo.description); //$NON-NLS-1$
						self._selectFolder(qinfo.parentUuid);
		            	self.onContentChange();
		            	self.saveButton.firstChild.nodeValue = self._messages.SaveQuery;
		            	//handle queryParameters
		            	window.setTimeout(function() {
        				    if (qinfo.parameterized === "true" || qinfo.parameterized) { //getting boolean value as a string so explicitly comparing to "true" //$NON-NLS-1$
        		            	var parameters = queryData[namespaces.query.parameter];
        		            	qinfo.parameters = (parameters.length)? SystemParameterUtil.getParametersFromQueryInfo(data, parameters): null;
        		            	self._setParameters(qinfo.parameters);
        					} else {
        						self.hideParamTable();
        					}
        				}, 1);
	            	} 
				}
	        });
    	} else {
    		this.saveButton.firstChild.nodeValue = this._messages.CreateQuery;
    	}

    	this._queryInfo = queryInfo;
	},

	_setParameters: function(parameters) {
    	this._paramTable.clearBody();
		this._refreshParameters(parameters);
	},
	
	initWidgets: function() {
		this._enableSaveButtons(false);
	},

	onContentChange: function(parameterChanges) {
		var self = this;
		self.hideMessage();
		var qi = self._getQueryInfo();
		var isDirty = self.isDirty(parameterChanges===true);
		this._enableSaveButtons(isDirty && ( qi.queryName && qi.queryName != "")&&( qi.sparql && qi.sparql != "") && (qi.parentUuid && qi.parentUuid != ""));	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		JazzUIWorkbench.setTitle(qi.queryName || "");//$NON-NLS-1$
	},
	
	isDirty: function(parameterChanges) {
		var self = this;
		var qi = self._getQueryInfo();
		var org = self._qInfo;

		var diffName = qi.queryName != org.queryName;
		var diffDesc = qi.description != org.description;
		var diffSparql = qi.sparql != org.sparql;
		//Need to check that there was an original parentUuid since new queries will never have one and
		//always seem dirty.
		var diffFolderUUID = org.parentUuid && qi.parentUuid != org.parentUuid;
		var saveEnabled = !this.saveButton.disabled;

		return (diffName || diffDesc || diffSparql || diffFolderUUID || saveEnabled || parameterChanges || this._qInfo.isDirty);
	},
	
	getSelectedFolder: function() {
		if(!this._folderTreeWidget){
			return null;
		}
		var currentFolderNode = this._folderTreeWidget.getSelection();
		var currentFolder = this._folderInfo._folderMap[currentFolderNode];
		if (!currentFolder || currentFolder == null) {
			return null;
		}

		// If this is a special folder, just set the sharing flag. Otherwise
		// set the parent folder.
//		if (currentFolder.processAreaUUID == null) {
//			args.sharedIfNullFolder = currentFolder.shared;
//		} else {
			return currentFolder;
//		}
	},

    onQuery: function(evt){
    	var content = this._getQueryInfo();
    	var validData = this.refreshAndGetData(content);
    	if (!validData) return;

    	if (this.isDirty()) {
    		content._dirtyMessages = {
    			okOrCancelMessage: this._messages.okOrCancel,
    			unsavedChangesMessage: this._messages.unsavedChanges,
    			navigateAwayMessage: this._messages.navigateAway
    		};
    		content.isDirty = true;
    	}
		dojo.publish("EXECUTE_QUERY", [content]); //$NON-NLS-1$
	},
	
	onSave: function(evt){
    	if(!this.nameNode.get("value")){ //$NON-NLS-1$
    		this.nameNode.set("value", this._messages.NewQuery); //$NON-NLS-1$
    	}
    	this._saveQuery();
	},
	
	onSaveAs: function(evt){
		this._qInfo.queryUri = null;
		var oldName = this.nameNode.get('value'); //$NON-NLS-1$
    	this.nameNode.set("value", dojo.string.substitute(this._messages.CopyOf, [this.nameNode.value]));  //$NON-NLS-1$
    	var saveSuccessful = this._saveQuery();
    	if (!saveSuccessful) {
    		this.nameNode.set('value', oldName); //$NON-NLS-1$
    	}
	},
	
	onCancel: function(){
		// Remove spell check attribute
		if(dojo.isFF !== undefined)
			dojo.body().removeAttribute("spellCheck"); //$NON-NLS-1$
		var qInfo = this._qInfo ;
		if(this._queryInfo && !this._queryInfo.edit && (qInfo.queryUri || qInfo.sparql)){
			// edit flag is true only when called from QueryList page
			this.destroy();
			if(qInfo.queryUri) {
				dojo.publish("EXECUTE_QUERY", [qInfo]); //$NON-NLS-1$
			} else {
				window.location.href = "#action=com.ibm.relm.explorer.web.showQueryList"; //$NON-NLS-1$
			}
		}else{
			window.location.href = "#action=com.ibm.relm.explorer.web.showQueryList"; //$NON-NLS-1$
		}
	},

	/**
	* Refresh the parameter table, get the data from the parameter table and validate the data. 
	* 
	* @param {queryInfo} Information about the query. Should always be passed in. Info about parameters is added to it.
	* @return (boolean) true if successful, false otherwise
	*/
	refreshAndGetData: function(queryInfo) {
		if (!queryInfo) {
			throw new Error("Query info not provided to QueryEditor.refreshAndGetData"); //$NON-NLS-1$
		}

		this._refreshParameters();

		var parameters = this._paramTable.getData();
		queryInfo.parameters = parameters;
		queryInfo.parameterized = (parameters && parameters.length > 0).toString();

		return this._validateParameters(parameters);
	},


	/**
	* Validates that all the required info for a parameter is provided.
	* Originally there were multiple fields to validate, but now since the type
	* is preselected to a default value, label is the only value that can be
	* missing. 
	*
	* @param (parameters[]) The parameter data to validate
	* @return (boolean) true if valid data, false otherwise
	*/
	_validateParameters: function(parameters) {
		var invalidParameters = [];
		dojo.forEach(parameters, function(parameter) {
			for (prop in parameter) {
				if (!parameter[prop]) {
					//Technically a parameter could have a missing name, but this would be a programming error and should never occur
					invalidParameters.push(parameter.name);
				}
			}
		});
		
		if (invalidParameters.length == 0) {
			return true;
		} else {
			//Flash the nodes
			dojo.forEach(invalidParameters, function(parameterName) {
				var row = this._rowFor(parameterName);
				if (row) {
					row.focus();
					commonUtil.flashNode(row);
				}
			}, this);

			//Append all incorrect parameters to error message
			//XXX: To get around visual freeze, requiring ParameterTableMessages instead of adding one message to QueryEditorMessages
			var stringOfNames = invalidParameters.join(", "); //$NON-NLS-1$
			var errorMessage = dojo.replace(this._parameterTableMessages.missingParameterInfo, [stringOfNames]);
			this._showWarningMessage(errorMessage);
			
			return false;
		}
	},
	
	_rowFor: function(parameterName) {
		var foundRow = null;
		
		dojo.some(this._paramTable.tbody.rows, function(row){
			if (row.parameterName == parameterName) {
				foundRow = row;
				return true;
			}
		});
		
		return foundRow;
	},
	
	_saveQuery: function() {
		this.hideMessage();
		var message = com.ibm.relm.common.web.StatusMessage.show(this._queryMessages.saving);

		var queryInfo = this._getQueryInfo();
		var validData = this.refreshAndGetData(queryInfo);
		if (!validData) {
			message.hide();
			return false;
		}

		if(!queryInfo.queryName || !queryInfo.sparql){
			// error
			message.hide();
			return false;
		}
		if(!queryInfo.parentUuid) {
			// need to select folder
			this._showErrorMessage(this._messages.pleaseSelectFolder);
			message.hide();
			return false;
		}
		var url = com.ibm.relm.explorer.web.ui.queryServiceUri;
		var content = {
				contentType: "application/rdf+xml", //$NON-NLS-1$
				queryName: queryInfo.queryName,
				description: queryInfo.description,
				scope: queryInfo.scope,
				sparql: queryInfo.sparql,
				parentUUID: queryInfo.parentUuid,
				parameters: dojo.toJson(queryInfo.parameters),
				parameterized: queryInfo.parameterized
		};

		// "PUT" for update an existing resource, "POST" for create a new resource
		var method;
		var hasBody = true;
		if(queryInfo.queryUri){
			method = "PUT"; //$NON-NLS-1$
			url = queryInfo.queryUri; 
			content.ownedBy = this._qInfo.owner; // use original owner
		} else {
			method = "POST";  //$NON-NLS-1$
		}
		var self = this;
		jazz.client.xhr(method, {
			url: url,
			content: content,
			contentType: "application/x-www-form-urlencoded; charset=utf-8", //$NON-NLS-1$
            preventCache: true,
            headers: {
            	ETag: this.eTag
            },
            handle: function() {
            	message.hide();
            },
            load: function(data, ioArgs){
            	// keep eTag for update/delete
            	self.eTag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
            	// update widget properties
            	var org = self._qInfo;
            	org.queryName = queryInfo.queryName;
            	org.description = queryInfo.description;
            	org.scope = queryInfo.scope;
            	org.sparql = queryInfo.sparql;
            	org.parentUuid = queryInfo.parentUuid;
            	org.isDirty = false;
            	
            	self.queryPage.setListDirty(org.scope);
            	
            	var message = self._messages.saveSuccess;
            	if(self._mode == "create" ) { //$NON-NLS-1$
            		self.saveButton.firstChild.nodeValue = self._messages.SaveQuery;
            		self.saveAsButton.style.display = ""; //$NON-NLS-1$
            		self._mode = "modify"; //$NON-NLS-1$
            		message = self._messages.createSuccess;
            		org.queryUri = ioArgs.xhr.getResponseHeader("Location");//$NON-NLS-1$
            	}
        		self._enableSaveButtons(false);
        		var status = {
        				type : jazz.ui.MessageBox.STATUS_TYPES.OK,
        				summary : message,
        				closable : false
        			};
        		self.messageArea.showMessage(status);
			},
			error: dojo.hitch(this, "errorHandler") //$NON-NLS-1$
		}, hasBody);
		return true;
	},

	_handleFolderSelectionChange: function(selection)
	{
//		this._setDirty(true);
		this.onContentChange();			
	},

	_enableSaveButtons: function(enable){
		var self = this;
		var selectedFolder = self.getSelectedFolder();
		if(enable){
			if( selectedFolder != null && 
					(( self.permissions.createPermission && self._mode == "create") || //$NON-NLS-1$
					 ( self.permissions.modifyPermission && self._mode == "modify") || //$NON-NLS-1$
					 ( selectedFolder.shared == false)) ){
				self.saveButton.disabled = ""; //$NON-NLS-1$
			}else {
				self.saveButton.disabled = "true"; //$NON-NLS-1$
			}
		}else{
			self.saveButton.disabled = "true"; //$NON-NLS-1$
		}
		if((selectedFolder != null) && (self._mode != "create") && (self.nameNode.get("value")) && //$NON-NLS-1$ //$NON-NLS-2$
				(self.permissions.createPermission || (selectedFolder.shared == false))) {
			self.saveAsButton.disabled = ""; //$NON-NLS-1$
		} else {
			self.saveAsButton.disabled = "true"; //$NON-NLS-1$
		}

	},

	/**
	* This doesn't include the information about parameters. To get parameter data, call getData
	* on the parameter table.
	*/
	_getQueryInfo: function() {
		var selectedFolder = this.getSelectedFolder();
		if(selectedFolder== null) {
			selectedFolder = {};
		} 

        var queryInfo = {
        	queryUri: this._qInfo.queryUri,
        	queryName: this.nameNode.get("value"), //$NON-NLS-1$
        	description: this.descriptionText.get("value"), //$NON-NLS-1$
        	scope: (selectedFolder.shared) ? "shared" : SCOPE_PERSONAL,//$NON-NLS-1$
	        sparql: this.queryText.get("value"), //$NON-NLS-1$
	        parentUuid: selectedFolder.folderUUID,
	    };
        return queryInfo;
	},
	
	_showErrorMessage: function(message) {
		var status = {
			type : jazz.ui.MessageBox.STATUS_TYPES.ERROR,
			closable : false
		};
		if (dojo.isString(message))
			status.summary = message;
		else 
			dojo.mixin(status, message);
//		dojo.addClass(this._messageBoxContainer, "messageBoxVisible");
		this.messageArea.showMessage(status);
		this.layout();
	},

	hideMessage: function() {
		this.messageArea.hide();
		this.layout();
	},

	/**
	* Displays a warning message to the user with the content being what is provided. 
	* The message can either just be a summary string or an object with the different parts of the message (summary, explanation and user action)
	*
	* @param message {String or Object}
	*/
	_showWarningMessage: function(message) {
		var status = {
			type : jazz.ui.MessageBox.STATUS_TYPES.WARNING,
			closable : true
		};
		if (dojo.isString(message))
			status.summary = message;
		else 
			dojo.mixin(status, message);
//		dojo.addClass(this._messageBoxContainer, "messageBoxVisible");
		this.messageArea.showMessage(status);
		this.layout();
	},
	
	_remoteError: function(error) {
		this._folderInfo._responseCount++;
		if(this._folderInfo._responseCount == 2){
			// both requests for shared and personal have been returned
			this._folderInfo._inprogress = false;
		}
		// Check if the content is still displaying
		if (!dojo.isDescendant(this.saveButton, document.body)) {
			// Not still displaying, ignore the error
			return;
		}
		this.messageArea.showMessage(this.errorMessages.invokeServiceError + error.message);
	},

    errorHandler: function(response, ioargs){
    	var message = com.ibm.relm.explorer.web.ui.internal.util.getXhrErrorMessage(response, ioargs);
    	this.messageArea.showMessage(message);
        if(response.responseText){
       		response.responseText = null; // don't show the message in error dialog
        }
	}

});

})();
	
