/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
// declare the Dojo module
dojo.provide("com.ibm.relm.explorer.web.ui.internal.compact.CompactRendering"); //$NON-NLS-1$

// declare dependencies on other Dojo modules
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojo.date.stamp"); //$NON-NLS-1$
dojo.require("dojo.date.locale"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$
dojo.require("jazz.app.auth"); //$NON-NLS-1$
dojo.require("jazz.app.proxy"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.xmlutils"); //$NON-NLS-1$


dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewListMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	

var xmlutils = com.ibm.relm.explorer.web.ui.internal.xmlutils;
// declare and implement the widget "class"
dojo.declare("com.ibm.relm.explorer.web.ui.internal.compact.CompactRendering", [ dijit._Widget, dijit._Templated ], { //$NON-NLS-1$
	widgetInTemplate: true, 
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/compact/templates/CompactRendering.html"), //$NON-NLS-1$ //$NON-NLS-2$
	
	postMixInProperties: function() {
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewListMessages");		 //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function(){
		this.inherited(arguments);
    	
		var query= new dojo._Url(dojo.doc.location).query;
    	var object= dojo.queryToObject(query);
    	this.setContent(object["viewUri"]); //$NON-NLS-1$
	},
	
	setContent: function(viewUri){
		var self = this;
		jazz.client.xhrGet({
			url: viewUri + "?properties=true", //$NON-NLS-1$
			headers: { "Accept": "application/json"},  //$NON-NLS-1$ //$NON-NLS-2$
			handleAs: "json", //$NON-NLS-1$
			load: function(data){
				self.description.innerHTML = com.ibm.relm.explorer.web.ui.internal.util.escapeHtml(data.description || ""); //$NON-NLS-1$
				self.created.innerHTML = self.formatDate(data.created); 
				self.modified.innerHTML = self.formatDate(data.modified); 
				if(data.creator){
					self.creator.href = data.creator;
					self.creator.innerHTML = data.creator;
					self.formatUser(data.creator);
				}
			}
		});
	},
	
	formatDate: function(date){
		if(!date) return ""; //$NON-NLS-1$
		try {
			return dojo.date.locale.format(dojo.date.stamp.fromISOString(date), {formatLength: "medium"}); //$NON-NLS-1$
		} catch(e){
			console.warn("Could not format date in hover: " + date); //$NON-NLS-1$
			// maybe passed date is not ISO format
		}
		return date;
	},
	
	formatUser: function(userUri){
		var self = this;
		jazz.client.xhrGet({
			url: userUri,
			headers: { "Accept": "application/rdf+xml" },  //$NON-NLS-1$ //$NON-NLS-2$
			handleAs: "xml", //$NON-NLS-1$
			load: function(data){
				var userName = xmlutils.getContent("name", data); //$NON-NLS-1$
				if(!userName){
					// for IE ... TODO not to assume j.0 as prefix...
					var names = data.getElementsByTagName("j.0:name"); //$NON-NLS-1$
					if(names && names.length){
						var userNameNode = names[0];
						userName = userNameNode.textContent || userNameNode.text;
					}
				}
				if(userName){
					self.creator.innerHTML = userName;
				}
			},
			error: function(ioargs){
				console.debug(ioargs);
			}
		});
	}
});

})();