/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012, 2016. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.list.FolderRow"); //$NON-NLS-1$

dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal.list", "FolderRowMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$


dojo.require("com.ibm.relm.explorer.web.ui.internal.list.ListRow"); //$NON-NLS-1$

(function() {

	var FOLDERTYPE = "folder"; //$NON-NLS-1$
	var FOLDER_ICON = dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/folder.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	var COLLAPSE_ICON = dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/images/collapse.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	var EXPAND_ICON = dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/images/expand.gif"); //$NON-NLS-1$ //$NON-NLS-2$

	dojo.declare(
		"com.ibm.relm.explorer.web.ui.internal.list.FolderRow", //$NON-NLS-1$
		[com.ibm.relm.explorer.web.ui.internal.list.ListRow],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.explorer.web','ui/internal/list/templates/FolderRow.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,
			messages: dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal.list", "FolderRowMessages"), //$NON-NLS-1$ //$NON-NLS-2$

			constructor: function(args, node) {
				this._handleFolderCheckBoxClick = args._handleFolderCheckBoxClick;
				this._handleFolderColExp = args._handleFolderColExp;
				
				this.guid = this.item.folderUUID;
				this.rowType = FOLDERTYPE;
				this.folderID = this.item.folderUUID;
				this.iconSrc = FOLDER_ICON;
				this.label = com.ibm.relm.explorer.web.ui.internal.util.escapeHtml(this.item.name.label);

				this._expanded = args._expanded;
				this.expandoIcon = (this._expanded == "true") ? COLLAPSE_ICON : EXPAND_ICON ; //$NON-NLS-1$
			},

			postCreate: function() {
				this.inherited(arguments);
				this.domNode._expanded = this._expanded;
			}
		});
	})();