/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$

dojo.require("com.ibm.relm.common.web.ui.util"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "utilMessages"); //$NON-NLS-1$ //$NON-NLS-2$

// Trying to have loose coupling with product def modules, but this
// is better for users when trying to show a product .
try {
	jazz.core.loader.load_async('com.ibm.relm.ple.web.ui.productapi', function() { //$NON-NLS-1$
		// no op callback
	});
}
catch (e) {
	// Doesn't matter, this is optional. Not sure if this throws or not, but this doesn't hurt.
}


(function(){
	
// URIs
com.ibm.relm.explorer.web.ui.serviceRoot = net.jazz.ajax._contextRoot + "/"; //$NON-NLS-1$
com.ibm.relm.explorer.web.ui.configServiceUri = com.ibm.relm.explorer.web.ui.serviceRoot + "relmui/config/";  //$NON-NLS-1$
com.ibm.relm.explorer.web.ui.queryServiceUri = com.ibm.relm.explorer.web.ui.serviceRoot + "relmui/query/"; //$NON-NLS-1$
com.ibm.relm.explorer.web.ui.folderServiceUri = com.ibm.relm.explorer.web.ui.serviceRoot + "relmui/folder"; //$NON-NLS-1$
com.ibm.relm.explorer.web.ui.uiComponentServiceUri = com.ibm.relm.explorer.web.ui.serviceRoot + "relmui/componentInfo"; //$NON-NLS-1$
com.ibm.relm.explorer.web.ui.matrixServiceUri = com.ibm.relm.explorer.web.ui.serviceRoot + "relmui/matrixInfo"; //$NON-NLS-1$

// Namespaces
var NS_DC = "http://purl.org/dc/terms"; //$NON-NLS-1$
var NS_QUERY = "http://relm.ibm.com/query/0.9"; //$NON-NLS-1$
var NS_RDFS = "http://www.w3.org/2000/01/rdf-schema"; //$NON-NLS-1$
var NS_RDF = "http://www.w3.org/1999/02/22-rdf-syntax-ns"; //$NON-NLS-1$
com.ibm.relm.explorer.web.ui.namespace = {
	query: {
		sparql: NS_QUERY + "/sparql", //$NON-NLS-1$
		scope: NS_QUERY + "/scope", //$NON-NLS-1$
		ownedBy: NS_QUERY + "/ownedBy", //$NON-NLS-1$
		parentUuid: NS_QUERY + "/parentUuid", //$NON-NLS-1$
		parameterized: NS_QUERY + "/parameterized_query", //$NON-NLS-1$
		parameter: NS_QUERY + "/parameter" //$NON-NLS-1$
	},
	parameter: {
		parameterName: NS_QUERY + "/parameterName", //$NON-NLS-1$
		parameterClass: NS_QUERY + "/parameterClass", //$NON-NLS-1$
		parameterType: NS_DC + "/type", //$NON-NLS-1$
		parameterLabel: NS_RDFS + "#label" //$NON-NLS-1$
	},
	dcterms: {
		title: NS_DC + "/title", //$NON-NLS-1$
		description: NS_DC + "/description", //$NON-NLS-1$
		contributor: NS_DC + "/contributor" //$NON-NLS-1$
	}
};

// icons
var knownIcons = {
	"http://open-services.net/ns/cm#ChangeRequest": "work-item.png", //$NON-NLS-1$ //$NON-NLS-2$
	"http://open-services.net/ns/qm#TestPlan": "test-plan.png", //$NON-NLS-1$ //$NON-NLS-2$
	"http://open-services.net/ns/qm#TestCase": "test-case.png", //$NON-NLS-1$ //$NON-NLS-2$
	"http://open-services.net/ns/qm#TestScript": "test-script.png", //$NON-NLS-1$ //$NON-NLS-2$
	"http://open-services.net/ns/qm#TestExecutionRecord": "test-execution-record.png", //$NON-NLS-1$ //$NON-NLS-2$
	"http://open-services.net/ns/qm#TestResult": "test-results.png", //$NON-NLS-1$ //$NON-NLS-2$
	"http://open-services.net/ns/rm#Requirement": "requirement.png", //$NON-NLS-1$ //$NON-NLS-2$
	"http://open-services.net/ns/rm#RequirementCollection": "requirement-collection.png", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#Actor": "dm/actor.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#UseCase": "dm/usecase.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#SequenceDiagram": "dm/sequenceDiagram.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#Operation": "dm/operation.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#Port": "dm/port.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#EnumerationLiteral": "dm/umlType.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#Requirement": "dm/dmRequirement.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#AssociationEnd": "dm/associationEnd.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#Tag": "dm/umlClass.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#UseCaseDiagram": "dm/useCaseDiagram.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#Package": "dm/package.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/dm/rhapsody/uml#Object": "dm/umlObject.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/pd#ItemVersion": "product_co.gif", //$NON-NLS-1$ //$NON-NLS-2$
	"http://jazz.net/ns/pd#Item": "product_co.gif" //$NON-NLS-1$ //$NON-NLS-2$
};

var iconModule = dojo.moduleUrl("com.ibm.relm.ple.web", "ui/images/"); //$NON-NLS-1$ //$NON-NLS-2$

var _messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "utilMessages"); //$NON-NLS-1$ //$NON-NLS-2$

//function to allow delayed calling of a function and providing it 'this' context.
//found this technique at http://www.digital-web.com/articles/scope_in_javascript/
//Use it when a event handling function needs to call methods on the object that use "class" variables.
//Should be moved to a utility module.
Function.prototype.bind = function(obj) 
{
	var method = this;
	var temp = function() 
	{
		return method.apply(obj, arguments);
	}; 
	return temp;
}; 

var STR_PERMISSION_CREATE = "create"; //$NON-NLS-1$
var STR_PERMISSION_DELETE = "delete"; //$NON-NLS-1$
var STR_PERMISSION_MODIFY = "modify"; //$NON-NLS-1$
var STR_PERMISSION_CHANGEPARAMETER = "changeParameters"; //$NON-NLS-1$

// utilities
com.ibm.relm.explorer.web.ui.internal.util = {
	getIconForArtiactType: function(type){
		var iconFileName = knownIcons[type];
		if(iconFileName) {
			return iconModule + iconFileName;
		}
		return dojo.moduleUrl("com.ibm.relm.explorer.web", "explorer/images/artifact.gif"); // default icon //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	getXhrErrorMessage: function(response, ioargs){
		var errorObject = {};
		var details = [];
        try {
        	var contentType = ioargs.xhr.getResponseHeader("Content-Type"); //$NON-NLS-1$
        	if(contentType.indexOf("text/json") !== 0 && contentType.indexOf("application/json") !== 0 && contentType.indexOf("application/javascript") !== 0){ //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
        		throw null;
        	}
			errorObject = dojo.fromJson(ioargs.xhr.responseText || response.responseText);
			if (errorObject.explanation) {
				details.push({
					message: errorObject.explanation,
					code: jazz.ui.MessageBox.STATUS_TYPES.OK
				});
			}
			if (errorObject.userAction) {
				details.push({
					message: errorObject.userAction,
					code: jazz.ui.MessageBox.STATUS_TYPES.OK
				});
			}
			if(details.length === 0){
				if(!errorObject.summary) {
					if(errorObject.errorCause){
						errorObject.summary = errorObject.errorCause.errorMessage || errorObject.errorMessage || response.message;
					}
					if(!errorObject.summary) errorObject.summary = errorObject.errorMessage || response.message;
				}
				details.push({
					message: errorObject.errorCause ? (errorObject.errorCause.detailedMessage || errorObject.errorCause.errorMessage) : null,
					code: jazz.ui.MessageBox.STATUS_TYPES.ERROR
				});
			}
		}
		catch (e) {
			console.error('Unexpected error format. Not JSON.', e); //$NON-NLS-1$
			errorObject = {
				type: jazz.ui.MessageBox.STATUS_TYPES.ERROR,
				summary: _messages.unknownError
			};	
			details.push({
				message: ioargs.xhr.responseText || response.responseText,
				code: jazz.ui.MessageBox.STATUS_TYPES.ERROR
			});
		}
		return {
			type: errorObject.type || jazz.ui.MessageBox.STATUS_TYPES.ERROR,
			summary: errorObject.summary || errorObject || _messages.unknownError,
			details: details,
			closable: true
		};
	},
	
	// permission
	parsePermission: function(strArrayPermissions) {
		var permissions = {
				createPermission: false, // permission to create new configuration
				deletePermission: false, // permission to delete configuration
				modifyPermission: false // permission to modify whole configuration
		};
		dojo.forEach(strArrayPermissions, function(str) {
			switch(str) {
			case STR_PERMISSION_CREATE:
				permissions.createPermission = true;
				break;
				
			case STR_PERMISSION_DELETE:
				permissions.deletePermission = true;
				break;
				
			case STR_PERMISSION_MODIFY:
				permissions.modifyPermission = true;
				break;

			case STR_PERMISSION_CHANGEPARAMETER:
				// fall back - ignore if project area has old permission definition for changeParameters
				break;

			default:
				throw new Error('Unknown permission: ' + str); //$NON-NLS-1$
			}
		});
		
		return permissions;
	},
	
	/**
	 * Special way to show a product definition. If
	 * the productapi code is loaded (trying not to be too tightly coupled),
	 * this a special function is used that can directly open the product tree
	 * or show a disambiguration page if in multiple places. Otherwise, falls
	 * back to a simpler #action.
	 * @param  {string} uri URI to a product.
	 */
	showProduct: function(uri) {
		// This is a local Product Definition. Go directly to it in this window.
		// Note that if we were to load this OSLC style URL it would result in a redirect to the HTML
		// page, which is much slower since the browser treats it like a full page load, not an ajax load.
		// Just updating the #action is dramatically faster.
		if (dojo.exists('com.ibm.relm.ple.web.ui.productapi')) { //$NON-NLS-1$
			com.ibm.relm.ple.web.ui.productapi.findPathsToProductAndShow(uri);
		}
		else {
			// If 'productapi' is not loaded, could that mean that
			// all product actions are missing too? Is this a safe fallback?
			// Or should we just show the URL directly?
			window.location.href = '#' + dojo.objectToQuery({ //$NON-NLS-1$
				action: 'ple.read_only_product', //$NON-NLS-1$
				product: uri
			});
		}
	},

	/**
	 * Check if specified uri is a product definition or not.
	 * @param  {string} uri URI to artifact that may be a product.
	 */
	isProduct: function(uri) {
		var l = window.location;
		var productUriHead = l.protocol + '//' + l.host + net.jazz.ajax._contextRoot + '/productdef/resource/itemVersion_'; //$NON-NLS-2$ //$NON-NLS-1$

		return uri.indexOf(productUriHead) === 0;
	},
	
	/**
	 * If the URI looks like it's too a local product definition,
	 * tries to efficiently show it in this window, directly in the product
	 * tree is possible.
	 * @param  {string} uri URI to artifact that may be a product.
	 * @return {boolean}     true if it was a product and was shown. Otherwise false.
	 */
	showIfProduct: function(uri) {
		if (this.isProduct(uri)) {
			this.showProduct(uri);
			return true;
		}
		else {
			return false;
		}
	},
	
	/**
	 * Escape HTML for RELM config.
	 * Text in RELM config is escaped in ViewConfigJSONUtil.java in 6.0.1, 
	 * but old config may contain "<" and ">" characters which should be escaped. 
	 */
	escapeHtml: com.ibm.relm.common.web.ui.util.escapeHtml,

	unescapeHtml: com.ibm.relm.common.web.ui.util.unescapeHtml,

	/**
	 * Get sanitized uri.
	 */
	isValidUrl: function(url){
		// Make sure that the url will be considered valid by dojo Url class
		try {
			if(!dojo.isString(url)){
				return false;
			}
			var dojoUrl = new dojo._Url(url); // validate URL
			var scheme = (dojoUrl.scheme || "").toLowerCase();//$NON-NLS-1$
			if(scheme === "javascript" || scheme === "vbscript"){//$NON-NLS-1$//$NON-NLS-2$
				// don't allow protocols
				return false;
			}
		} catch (e) {
			return false;
		}
		return true;
	},
	
	sanitizeUrl: function(url) {
		if(com.ibm.relm.explorer.web.ui.internal.util.isValidUrl(url)){
			return url;
		}
		return "_" + url; // sanitize scheme part //$NON-NLS-1$
	},

	/**
	 * Shows an artifact (URI) in a new window, or this window
	 * it's a local product definition.
	 * 
	 * @param  {string} uri artifact URI.
	 * @param {boolean} openInNewWindow optional. If omitted or 'true',
	 * artifact will open a new window. If 'false', will reused this window.
	 */
	showArtifact: function(uri, openInNewWindow) {
		if (this.showIfProduct(uri)) {
			return;
		}
		else if(com.ibm.relm.explorer.web.ui.internal.util.isValidUrl(uri)){
			if (openInNewWindow === undefined || openInNewWindow) {
				var w = window.open(uri);
				w && w.focus();			
			}
			else {
				// I think you can just use window.open with a target of _self, but haven't verified across browsers.
				dojo.doc.location = uri;
			}
		}
	},
	
	/*
	 * Picker related utilities
	 */
	_pickerMap: {
		"product": "com.ibm.relm.ple.web.ui.picker.ProductPicker",//$NON-NLS-1$//$NON-NLS-2$
		"artifact": "com.ibm.relm.ple.web.ui.picker.LqeArtifactPicker", //$NON-NLS-1$//$NON-NLS-2$
		"color": "com.ibm.relm.explorer.web.ui.internal.view.common.ColorPicker", //$NON-NLS-1$//$NON-NLS-2$
		"fill": "com.ibm.relm.explorer.web.ui.internal.view.common.FillPicker", //$NON-NLS-1$//$NON-NLS-2$
		"stroke": "com.ibm.relm.explorer.web.ui.internal.view.common.StrokePicker", //$NON-NLS-1$//$NON-NLS-2$
		"path": "com.ibm.relm.explorer.web.ui.internal.view.common.PathPicker", //$NON-NLS-1$//$NON-NLS-2$
		"decoration": "com.ibm.relm.explorer.web.ui.internal.view.common.DecorationPicker", //$NON-NLS-1$//$NON-NLS-2$
		"childLinkId": "com.ibm.relm.explorer.web.ui.internal.view.common.ChildLinkIdsPicker" //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	hasPicker: function(type){
		return  this._pickerMap[type];
	},
	
	openPicker: function(type, initialValue, dialogTitle, okCallback, scope, config){
		var pickerClass = this._pickerMap[type];
		if(pickerClass) {
			jazz.core.loader.load_async(pickerClass, function() { 
				var ctor = dojo.getObject(pickerClass);
				if(ctor){
					var picker = new ctor({
						value: initialValue, 
						config: config,
						dialogTitle: dialogTitle,
						onOk: function(value){
							dojo.hitch(scope || this, okCallback)(value);
						}
					});

					picker.startup();
				}
			});
			return true;
		}
		return false;
	},
	
	/**
	 * Get an option value in URL. e.g. https://server/relm?editSrc=true#...
	 * @param  {string} option name. e.g. editSrc
	 */
	getURLOption: function(option){
		var queryString = dojo.doc.location.search;
		// allow source editing
		if(queryString.length > 1){
			queryString = queryString.substring(1);
			return dojo.queryToObject(queryString)[option];
		}
		return null;
	},

	/**
	 * Check an option in URL. e.g. https://server/relm?editSrc=true#...
	 * @param  {string} option name. e.g. editSrc
	 */
	checkURLOption: function(option){
		var optvalue = this.getURLOption(option);
		return optvalue === "true";//$NON-NLS-1$
	},

	/**
	 * Get an option value in URL. e.g. https://server/relm#relm.showOutline=true#...
	 * @param  {string} option name. e.g. relm.showOutline
	 */
	getURLHash: function(name){
		var hash = dojo.doc.location.hash;
		if(hash.length > 1){
			hash = hash.substring(1);
			return dojo.queryToObject(hash)[name];
		}
		return null;
	}

};

})();

