/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.ConfigList"); //$NON-NLS-1$

dojo.require("dojo.date.stamp"); //$NON-NLS-1$
dojo.require("dojo.date.locale"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.ViewClient"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.MoveView"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.MetaNav"); //$NON-NLS-1$
////dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("dijit.form.ToggleButton"); //$NON-NLS-1$
//dojo.require("com.ibm.relm.explorer.web.ui.internal.view.ResourceList");
dojo.require("jazz.ui.FilterBox"); //$NON-NLS-1$
dojo.require("jazz.util.html"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.Toolbar"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.list.ListRow"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.list.FolderRow"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.list.ItemRow"); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.ui.internal.util'); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigListMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var JazzUIWorkbench = net.jazz.ajax.ui.PlatformUI.getWorkbench();
var ActionPrefix = "#action=com.ibm.relm.explorer.web.showViewList"; //$NON-NLS-1$
var FOLDERTYPE = "folder"; //$NON-NLS-1$
var VIEWTYPE = "view"; //$NON-NLS-1$
var INDENT = 20;
var INDENT2 = 40;

var ViewClient = com.ibm.relm.explorer.web.ui.internal.view.ViewClient;
var ServiceResponseHandler = com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler;
var FilterBox = jazz.ui.FilterBox;
var StyledTable = jazz.ui.StyledTable;
var PlatformUI = net.jazz.ajax.ui.PlatformUI;

var FolderRow = com.ibm.relm.explorer.web.ui.internal.list.FolderRow;
var ItemRow = com.ibm.relm.explorer.web.ui.internal.list.ItemRow;

var COLLAPSE_ICON = dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/images/collapse.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var EXPAND_ICON = dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/images/expand.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.ConfigList",  //$NON-NLS-1$
		[dijit._Widget, dijit._Templated],
{
	diagramPage: null,
	myViewsTab: null,
	sharedViewsTab: null,
	_childMap: {},
	_colexpState: {},
	_folders: {},
	_widgets: [],
	_callCount: 0,
	_previousSelectedViewUri: null,
	_prevSelectedRow: null,
	_refreshRequired: false,
	
	runViewAction: "#action=com.ibm.relm.explorer.web.showDiagram", //$NON-NLS-1$
	editFolderAction:"#action=com.ibm.relm.explorer.web.editViewFolder", //$NON-NLS-1$

	// template
    widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/internal/view/templates/ConfigList.html"), //$NON-NLS-1$ //$NON-NLS-2$

	
	postMixInProperties: function() {
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigListMessages");		 //$NON-NLS-1$ //$NON-NLS-2$
	},

	postCreate: function(){
		this.inherited(arguments);
		var messages = this._messages;
		this.shared = (this.scope == "shared") ? true : false; //$NON-NLS-1$
		// set title
		this.myViewsTab = new dijit.form.ToggleButton({label: this._messages.PrivateViews});
		this.connect(this.myViewsTab, "onClick", "onMyViews"); //$NON-NLS-1$ //$NON-NLS-2$
		this.sharedViewsTab = new dijit.form.ToggleButton({label: this._messages.SharedViews});
		this.connect(this.sharedViewsTab, "onClick", "onSharedViews"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.place(this.myViewsTab.domNode, this.titleArea);
		dojo.place(this.sharedViewsTab.domNode, this.titleArea);

		this._filterBox = new FilterBox({onChange: dojo.hitch(this,this._doFilter)});
		this._filterArea.appendChild(this._filterBox.domNode);
		this._table = new StyledTable({columns: [{label: messages.Name, width: "30%", sortable: true}, //$NON-NLS-1$
		                                         {label: messages.CreatedBy, width: "14%", sortable: true}, //$NON-NLS-1$
		                                         {label: messages.LastUpdated, width: "14%", sortable: true}, //$NON-NLS-1$
		                                         {label: messages.Actions, width: "12%", className: "action-column", sortable: false}], //$NON-NLS-1$ //$NON-NLS-2$
		                                        trim: jazz.ui.StyledTable.TrimStyles.PRIMARY_HEADLESS, 
		                                        handleSort: dojo.hitch(this, this._handleSort),
		                                        sortBy: 0,
		                                        sortByAscending: true,
		                                        showHover: true});
		this._resultsArea.appendChild(this._table.domNode);
		this._populateHeader();
		// initialize permission
		this.initPermission();
	},

	/**
	*	This is the function that is used to handle the sorting of the styled table. 
	*/
	_handleSort: function() {
		this._emptyTable();
		this._sortChildren(this._rootFolder.children, null, 9, this._rootFolder.folderUUID, true);
	},

	/**
	 * Function to recursively sort folders
	 */
	_sortChildren: function(children, parentDiv, parentPadding, parentUUID, fShow) {
		parentDiv && this.showExpando(parentDiv, children.folders.length || children.views.length);
		var folders = children.folders;
		this._performSort(folders);
		dojo.forEach(folders, function(folder) {
			var folderDiv;
			var padding;
			if (parentDiv) {
				padding = parentPadding + INDENT;
				folderDiv = this._createFolderRow(folder, padding, fShow);
				this._insertAfter(folderDiv, this._getFolderInsertionPoint(parentDiv));
			}
			else {//In root folder 
				padding = 9;
				folderDiv = this._createFolderRow(folder, padding, true);
				this._table.tbody.appendChild(folderDiv);
			}
			this._sortChildren(folder.children, folderDiv, padding, folder.folderUUID,this._colexpState[folder.folderUUID]);
		}, this);
		//Sort views
		this._sortAndPlaceViews(children.views, parentDiv, parentPadding, parentUUID, fShow);
	},

	_sortAndPlaceViews: function(views, parentDiv, padding, folderUUID, fShow) {
		var inFolder = !!parentDiv;

		this._performSort(views);

		if (inFolder) {
			dojo.forEach(views, function(view) {
				this._insertAfter(this._createViewRow(view, padding + INDENT2, this._colexpState[folderUUID]), this._getViewInsertionPoint(folderUUID));
			}, this);
		} else {//In root folder 		
			dojo.forEach(views, function(view) {
				dojo.place(this._createViewRow(view, padding + INDENT, true), this._table.tbody, "last"); //$NON-NLS-1$
			}, this);
		}
	},

	/**
	*	Calls the appropriate sorting function on this Array based on which columns off 
	*	the table needs to be sorted
	*
	*	There are three sorting functions (name, date and creator). Each is called with dojo.partial
	*	which sneeks in a parameter to tell the function which order to sort in (ascending/descending)
	*	@param {Array} foldersOrRows 
	*/
	_performSort: function(foldersOrRows) {
		var table = this._table;
		var sortBy = table.sortBy;
		var aToz = table.sortByAscending;

		switch (sortBy) {
			case 0:
				return foldersOrRows.sort(dojo.hitch(this, dojo.partial(this._sortByName, aToz)));
			case 1: 
				return foldersOrRows.sort(dojo.hitch(this, dojo.partial(this._sortByCreator, aToz)));
			case 2:
				return foldersOrRows.sort(dojo.hitch(this, dojo.partial(this._sortByDate, aToz)));
		}
	},

	_sortByName: function(asc, row1, row2) {
		var retVal;
		var name1 = row1.name.label;
		var name2 = row2.name.label;
		retVal = name1.localeCompare(name2);

		if(asc)
			return retVal;
		else
			return retVal * -1;
	},

	_sortByDate: function(asc, row1, row2) {
		var date1 = dojo.date.stamp.fromISOString(row1.modified);
		var date2 = dojo.date.stamp.fromISOString(row2.modified);
		var retVal = date1 - date2;

		if(asc)
			return retVal;
		else
			return retVal * -1;
	},

	_sortByCreator: function(asc, row1, row2) {
		var name1 = this._getDisplayValue(row1.creator);
		var name2 = this._getDisplayValue(row2.creator);
		
		var retVal;
		retVal = name1.localeCompare(name2);

		if(asc)
			return retVal;
		else
			return retVal * -1;
	},	
	
	_populateHeader: function(){
		var messages = this._messages;
		var title = this.shared ? messages.SharedViews : messages.PrivateViews;
		this.metanav.setTitle(jazz.util.html.escape(title));

		var toolbar = new jazz.ui.SimpleToolbar({});
		this.metanav._toolbar = toolbar;
		this.metanav._toolbarDiv.appendChild(toolbar.domNode);
		toolbar.addButton(this, this._newView, {showLabel: true, imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web", "explorer/images/new_resource.gif"), label: messages.createView, requiresSelection:false, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._newFolder, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/new-folder-obj.gif"), label: this._messages.createFolder, requiresSelection:false, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._runNewView, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/refresh16.gif"), label: messages.refresh, requiresSelection:false});		 //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._deleteItems, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/delete_hov.gif"), label: messages.deleteViewMsg, requiresSelection:true, requireDelete:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._moveItems, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/movecopy.gif"), label: messages.moveView, requiresSelection:true, moveCopy: true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._exportViews, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/download_co.gif"), label: messages.exportViews, requiresSelection:true, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		this.refreshButton = this.metanav._toolbar.getItem(2);

		if(this.shared == true) this.metanav.createContextSensitiveHelp("com.ibm.relm.explorer.web.page_SharedViews001"); //$NON-NLS-1$
		else this.metanav.createContextSensitiveHelp("com.ibm.relm.explorer.web.page_MyViews001"); //$NON-NLS-1$
		
		if(this.displayBreadcrumbs) {
			this.metanav.populateReportsBreadcrumbs();
		} else {
			this.metanav.handle.style.height = "30px"; //$NON-NLS-1$
			this.metanav.handle.style.minHeight = "30px"; //$NON-NLS-1$
		}
	},	
	
	
	getTitleString: function(){
		if(this.myViewsTab.checked){
			return this.myViewsTab.label;
		} else {
			return this.sharedViewsTab.label;
		}
	},
	
	onMyViews: function(){
		window.location = ActionPrefix + "&scope=personal"; //$NON-NLS-1$
		JazzUIWorkbench.setTitle(this._messages.PrivateViews);
	},

	onSharedViews: function(){
		window.location = ActionPrefix + "&scope=shared"; //$NON-NLS-1$
		JazzUIWorkbench.setTitle(this._messages.SharedViews);
	},
	
	initPermission: function(){

		var self = this;
		jazz.client.xhrGet({
			url: com.ibm.relm.explorer.web.ui.configServiceUri + "?id=-1" + "&permission=", //$NON-NLS-1$ //$NON-NLS-2$
			headers: {"Accept":"application/json"}, //$NON-NLS-1$ //$NON-NLS-2$
			preventCache: true,
			handleAs: "json", //$NON-NLS-1$
			load: dojo.hitch(this, function(response, ioArgs){				
				self.permissions = com.ibm.relm.explorer.web.ui.internal.util.parsePermission(response);
				self._updateActions();

				// get list of queries and display them
				self._refreshContent();
			}),
			error: function(error) {
				alert(error.message);
			}
		});

	},
	
	_runNewViewForView: function(event){
		if(this._callCount > 0) {
			return;
		}
		this._refreshContent();
	},

	_runNewView: function() {
		var self = this;
		if(self._callCount > 0) {
			return;
		}
		self._refreshContent();
	},

	// should be called before ExplorerClient call
	_incCount: function() {
		if(this._callCount == 0) {
			this.metanav._toolbar.disableButton(this.refreshButton);
			JazzUIWorkbench.showMessage(this._messages.ExecutingQuery);
		}
		this._callCount++;
	},
	
	// should be called in ExplorerClient callbacks
	_decCount: function() {
		this._callCount--;
		if(this._callCount <= 0) {
			this.metanav._toolbar.enableButton(this.refreshButton);
			JazzUIWorkbench.hideMessageArea();	            	
			this._callCount = 0;
			if(	this._prevSelectedRow && this._prevSelectedRow.domNode) {
				this._prevSelectedRow.domNode.scrollIntoView();
				dijit.focus(this._prevSelectedRow.domNode.children[0].lastChild);
				this._previousSelectedViewUri = null;
				this._prevSelectedRow = null;
			}
		}
	},
	
	_refreshContent: function(pageUrl) { // was _runNewView
		this.inherited(arguments);
		this.messageArea.hideMessage();
		this.floatViews = true;
		var self = this;

		this.refreshTabs();

		var title = this.shared ? this._messages.SharedViews : this._messages.PrivateViews;
		JazzUIWorkbench.setTitle(title);

		var responseHandler = new ServiceResponseHandler(
				self,
				"_renderRootFolders", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ViewClient.getSystemRootFolderDescriptors(responseHandler);
	},	

	refreshTabs:function() {
		this.myViewsTab.set('checked', !this.shared); //$NON-NLS-1$
		this.sharedViewsTab.set('checked', this.shared); //$NON-NLS-1$
	},
	
	_emptyTable: function() {
		var widgets = dijit.findWidgets(this._table.domNode);
		dojo.forEach(widgets, function(widget) {
			widget.destroyRecursive();
		});
		this._table.clearBody();
	},

	getTr: function(guid) {
		return dojo.query('[data-guid=' + guid + ']')[0]; //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	_getFoldersFromResult: function(response){

		return dojo.map(response.results.bindings, function(r){
			return { 
				"name": {  //$NON-NLS-1$
					label: r.name.value, 
					type: "uri",  //$NON-NLS-1$
					value: r.uri.value
				}, 
				"children" : { folders: [], views: []}, //$NON-NLS-1$
				"description": (r.description) ? r.description.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"creator": r.creator, //$NON-NLS-1$
				"modified": (r.modified) ? r.modified.value : "",            			 //$NON-NLS-2$ //$NON-NLS-1$
				"ownedBy": (r.ownedBy) ? r.ownedBy.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"parentUUID": (r.parentUuid) ? r.parentUuid.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"folderUUID": (r.folderUUID) ? r.folderUUID.value : "" //$NON-NLS-1$ //$NON-NLS-2$
			};
		});
	},
	
	// The root folders here are either "shared" or "my views"
	// callback
	_renderRootFolders: function(response) {
		var folders = this._getFoldersFromResult(response);

		if (folders.length != 2) {
			// Something went wrong
			console.error("Root folder for Views contains " + folders.length + " folder(s).: \n" + dojo.toJson(folders));//$NON-NLS-1$ //$NON-NLS-2$
			this._decCount();
			return;
		}
		var index = (this.shared == true) ? 1 : 0;
		this._rootFolder = folders[index];
		this._folders[this._rootFolder.folderUUID] = this._rootFolder;
		this._renderChildFoldersForParent(this._rootFolder.folderUUID, true);
		this._renderChildsWithoutProjectArea();
		this._decCount();
	},
	
	// Get the childs under root folder without project area property ( for migration)
	_renderChildsWithoutProjectArea: function (){
		var args = {
				scope: (this.shared) ? "shared" : "personal", //$NON-NLS-1$ //$NON-NLS-2$
				flags: ViewClient.ALL,
				sortByName: true
		};
		var responseHandler = new ServiceResponseHandler(
				this,
				"_addChildFoldersNonpa", //$NON-NLS-1$ 
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ViewClient.getFolderDescriptorsUnderNonProjectAreaRootFolder(responseHandler, args);		
		var args2 = {
				scope: (this.shared) ? "shared" : "personal", //$NON-NLS-1$ //$NON-NLS-2$
				sortByName: true
		};
		if (this._currentFilter) {
			args2.filter = this._currentFilter;
		}
		var responseHandler2 = new ServiceResponseHandler(
				this,
				"_addChildViewsNonpa", //$NON-NLS-1$ 
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ViewClient.getConfigDescriptorsUnderNonProjectAreaRootFolder(responseHandler2, args2);
	},
	
	// Gets the child folders for either "shared views" or "my views"
	_renderChildFoldersForParent: function(folderUUID, fShow){

		this._emptyTable();
		this._updateActions();
		if (this._runViewTimeout) {
			clearTimeout(this._runViewTimeout);
			delete this._runViewTimeout;
		}
		if (!this._nextViewId)
			this._nextViewId = 1;
		var args = {
				parentUUID: folderUUID,
				flags: ViewClient.ALL,
				sortByName: true
		};
		var responseHandler = new ServiceResponseHandler(
				this,
				(fShow) ? "_addChildFoldersShow" : "_addChildFoldersHide", //$NON-NLS-1$ //$NON-NLS-2$
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ViewClient.getFolderDescriptors(responseHandler, args);
		var args2 = {
				parentUUID: folderUUID,
				sortByName: true
		};
		if (this._currentFilter) {
			args2.filter = this._currentFilter;
		}
		var responseHandler2 = new ServiceResponseHandler(
				this,
				(fShow) ? "_addChildViewsShow" : "_addChildViewsHide", //$NON-NLS-1$ //$NON-NLS-2$
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ViewClient.getConfigDescriptors(responseHandler2, args2);
		// for queries which do not belong to any folder
		if(this.floatViews) {

			var args3 = {
					parentUUID: "", //$NON-NLS-1$
					scope: (this.shared) ? "shared" : "personal", //$NON-NLS-1$ //$NON-NLS-2$
							sortByName: true
			};
			if (this._currentFilter) {
			args3.filter = this._currentFilter;
			}
			var responseHandler3 = new ServiceResponseHandler(
					this,
					(fShow) ? "_addChildViewsShow" : "_addChildViewsHide", //$NON-NLS-1$ //$NON-NLS-2$
			"_remoteError"); //$NON-NLS-1$
			this._incCount();
			ViewClient.getConfigDescriptors(responseHandler3, args3);
		}
	},

	// callback
	_addChildFoldersNonpa: function(response) {
		response.nonpaFolder = true;
		this._addChildFolders(response, true);
		this._decCount();
	},

	// callback
	_addChildFoldersShow: function(response) {
		this._addChildFolders(response, true);
		this._decCount();
	},

	// callback
	_addChildFoldersHide: function(response) {
		this._addChildFolders(response, false);
		this._decCount();
	},

	_addChildFolders: function(response, fShow) {
		PlatformUI.getWorkbench().hideMessageArea();
//		How many filters are already in the list
		var results = this._getFoldersFromResult(response);

		if (results != null) {
			this._performSort(results);
			for (var i = 0; i < results.length; i++) {
				var folder = results[i];
				this._childMap[folder.folderUUID] = new Array();
				this._folders[folder.folderUUID] = folder;
//				Locate the parent to insert it under
				if (folder.parentUUID == this._rootFolder.folderUUID || folder.parentUUID == null || response.nonpaFolder) {
					var folderRow = this._createFolderRow(folder, 9, fShow);
					this._table.tbody.appendChild(folderRow);
					this._rootFolder.children.folders.push(folder);
				} else {
					var parentUUID = folder.parentUUID;
					var parentDiv = this.getTr(parentUUID);
					var parentObj = this._folders[parentUUID];
					if (parentDiv == null || parentObj == null) {
						console.warn("Parent not found for folder"); //$NON-NLS-1$
					} else {
						this.showExpando(parentDiv, true);
						this._childMap[folder.parentUUID].push(folder.folderUUID); //MFV added folders to the child map to handle click on parent folder checkbox
						this._insertAfter(this._createFolderRow(folder, parentDiv._indent + INDENT, fShow), this._getFolderInsertionPoint(parentDiv));
						parentObj.children.folders.push(folder);
					}
				}
			}
//			Recurse
			for (var i = 0; i < results.length; i++) {
				var folder = results[i];
				var args = {
						parentUUID: folder.folderUUID,
						flags: ViewClient.ALL,
						sortByName: true
				};
				var responseHandler = new ServiceResponseHandler(
						this,
						(this._colexpState[folder.folderUUID]) ? "_addChildFoldersShow" : "_addChildFoldersHide", //$NON-NLS-1$ //$NON-NLS-2$
				"_remoteError"); //$NON-NLS-1$
				this._incCount();
				ViewClient.getFolderDescriptors(responseHandler, args);
				var args2 = {
						parentUUID: folder.folderUUID,
						sortByName: true
				};
				if (this._currentFilter) {
					args2.filter = this._currentFilter;
				}
				var responseHandler2 = new ServiceResponseHandler(
						this,
						(this._colexpState[folder.folderUUID]) ? "_addChildViewsShow" : "_addChildViewsHide", //$NON-NLS-1$ //$NON-NLS-2$
				"_remoteError"); //$NON-NLS-1$
				this._incCount();
				ViewClient.getConfigDescriptors(responseHandler2, args2);
			}
		}
	},

	_getFolderInsertionPoint: function(folderTRNode) {
		var candidate = folderTRNode;
		var nextCandidate = candidate.nextSibling;
		while (true) {
			if (nextCandidate == null) {
				return candidate;
			}
			var tmp2 = folderTRNode._indent + (INDENT2 - INDENT);
			var tmp = nextCandidate._indent < tmp2;
			if (nextCandidate._rowType == VIEWTYPE || tmp){
				return candidate;
			}
			candidate = nextCandidate;
			nextCandidate = nextCandidate.nextSibling;
		} 
	},

	_getViewsFromResult: function(response) {
		return dojo.map(response.results.bindings, function(r){
			return { 
				"name": {  //$NON-NLS-1$
					label: r.title.value, 
					type: "uri",  //$NON-NLS-1$
					value: r.uri.value,
					iconSrc: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/view.gif") //$NON-NLS-1$ //$NON-NLS-2$
				}, 
				"description": (r.description) ? r.description.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"creator": r.creator, //$NON-NLS-1$
				"modified": (r.modified) ? r.modified.value : "",  //$NON-NLS-1$ //$NON-NLS-2$
				"parentUUID": (r.parentUUID) ? r.parentUUID.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"ownedBy": (r.ownedBy) ? r.ownedBy.value : "" //$NON-NLS-1$ //$NON-NLS-2$
			};
		});

	},

	// callback
	_addChildViewsNonpa: function(response) {
		response.nonpaView = true;
		this._addChildViews(response, true);
		this._decCount();
	},
	// callback
	_addChildViewsShow: function(response) {
		this._addChildViews(response, true);
		this._decCount();
	},
	// callback
	_addChildViewsHide: function(response) {
		this._addChildViews(response, false);
		this._decCount();
	},

	_addChildViews: function(response, fShow) {
		var results = this._getViewsFromResult(response);
		PlatformUI.getWorkbench().hideMessageArea();
		if (results != null) {
			this._performSort(results);
			for (var i = 0; i < results.length; i++) {
				var view = results[i];
				if (this._childMap[view.parentUUID] == null)
					this._childMap[view.parentUUID] = new Array();
				this._childMap[ view.parentUUID].push(view.name.value);
//				Locate the parent to insert it under
				if (view.parentUUID == this._rootFolder.folderUUID || view.parentUUID == "" || response.nonpaView) { //$NON-NLS-1$
					this._table.tbody.appendChild(this._createViewRow(view, 29, fShow));
					this._rootFolder.children.views.push(view);
				} else {
					var parentFolder = this.getTr(view.parentUUID);
					if (parentFolder == null) {
//						Couldn't find the folder, so must be a root folder
						this._table.tbody.appendChild(this._createViewRow(view, 29, fShow));
						this._rootFolder.children.views.push(view);
					} else {
						this.showExpando(parentFolder, true);
						var parentUUID = view.parentUUID;
						this._insertAfter(this._createViewRow(view, parentFolder._indent + INDENT2, fShow), this._getViewInsertionPoint(parentUUID));
						this._folders[parentUUID].children.views.push(view);
					}
				}
			}
		}
	},


	_getViewInsertionPoint: function(folderUUID) {
		var folderTRNode = this.getTr(folderUUID);
		var candidate = folderTRNode;
		var nextCandidate = candidate.nextSibling;
		while (true) {
			if (nextCandidate == null) {
				return candidate;
			}
			if (nextCandidate._rowType == FOLDERTYPE || nextCandidate._indent <= folderTRNode._indent + (INDENT2 - INDENT)){
				return candidate;
			}
			candidate = nextCandidate;
			nextCandidate = nextCandidate.nextSibling;
		} 
	},

	_createViewRow: function(view, padding, fShow) {
		var listRow = new ItemRow({
			rowType: VIEWTYPE,
			item: view, 
			padding: padding, 
			fShow: fShow,
			_handleCheckBoxClick: dojo.hitch(this, this._handleCheckBoxClick),
			onResourceSelected: dojo.hitch(this, this.onResourceSelected)
		});
		if(view.name.value == this._previousSelectedViewUri) {
			this._prevSelectedRow = listRow;
		}
		this._widgets.push(listRow);
		this.initializeViewToolbar(listRow.item, listRow.actionBar);
		return listRow.domNode;
	},

	initializeViewToolbar: function(view, containerNode) {
		var messages = this._messages;
		var toolbar = new com.ibm.relm.explorer.web.explorer.page.Toolbar({});
		if(this.shared) {
			if(this.permissions.modifyPermission)
				toolbar.addButton(this, dojo.hitch(this, "_editView", view), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if(this.permissions.deletePermission)
				toolbar.addButton(this, dojo.hitch(this, "_deleteView", view), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/delete.gif"), label: messages.deleteViewMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			// always enable copy/move button
			toolbar.addButton(this, dojo.hitch(this, "_moveView", view), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/movecopy.gif"), label: messages.moveView}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		} else {
			toolbar.addButton(this, dojo.hitch(this, "_editView", view), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_deleteView", view), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/delete.gif"), label: messages.deleteViewMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_moveView", view), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/movecopy.gif"), label: messages.moveView}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		}
		containerNode.appendChild(toolbar.domNode);
	},

	initializeFolderToolbar: function(folder, containerNode) {
		var messages = this._messages;
		var toolbar = new com.ibm.relm.explorer.web.explorer.page.Toolbar({});
		if(this.shared){
			if(this.permissions.createPermission)
				toolbar.addButton(this, dojo.hitch(this, "_createNewFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/new-folder-obj.gif"), label: messages.createFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if(this.permissions.modifyPermission)
				toolbar.addButton(this, dojo.hitch(this, "_editFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if(this.permissions.deletePermission) 
				toolbar.addButton(this, dojo.hitch(this, "_deleteFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/delete.gif"), label: messages.deleteMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			// always enable copy/move button
			toolbar.addButton(this, dojo.hitch(this, "_moveFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/movecopy.gif"), label: messages.moveFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		} else {
			toolbar.addButton(this, dojo.hitch(this, "_createNewFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/new-folder-obj.gif"), label: messages.createFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_editFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_deleteFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/delete.gif"), label: messages.deleteMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_moveFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/movecopy.gif"), label: messages.moveFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		}
		containerNode.appendChild(toolbar.domNode);
	},	

	_createFolderRow: function(folder, padding, fShow) {
		var listRow = new FolderRow({
			item: folder, 
			padding: padding, 
			fShow: fShow,
			_handleFolderColExp: dojo.hitch(this, this._handleFolderColExp),
			_handleFolderCheckBoxClick: dojo.hitch(this, this._handleFolderCheckBoxClick),
			_expanded: (this._colexpState[folder.folderUUID]) ? "true" : "false" //$NON-NLS-1$ //$NON-NLS-2$,
		});
		this._widgets.push(listRow);
		this.initializeFolderToolbar(listRow.item, listRow.actionBar);
		return listRow.domNode;
	},

	_getDisplayValue: function(valueObject) {
		var value = valueObject.value;
		if (valueObject.label)
			return valueObject.label;
		else {
			var displayValue = decodeURIComponent(value.substring(value.lastIndexOf('/') + 1)); //$NON-NLS-1$
			//Try to cache the label so it doesn't need to computed again when sorting
			valueObject.label = displayValue;
			return displayValue;
		}
	},
	
	_insertAfter: function(newNode, referenceNode) {
		referenceNode.parentNode.insertBefore(newNode, referenceNode.nextSibling);
	},

	/**
	 * Toggles showing of the expando on a folder row
	 * @param  {Tr} folderRow       The folder row with the expando
	 * @param  {boolean} condition True indicates showing, False indicates hiding
	 */
	showExpando: function(folderRow, condition) {
		dojo.toggleClass(folderRow, 'noChildren', !condition); //$NON-NLS-1$
	},

	_handleFolderColExp: function(args) {
		var folderRow = args.currentTarget.parentNode.parentNode;
		var fShow = (folderRow._expanded == "false") ? "true" : "false"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		folderRow._expanded = fShow;
		this._collapseExpandFolder(folderRow, fShow);
		args.currentTarget.src = (fShow == "true") ?  COLLAPSE_ICON : EXPAND_ICON ; //$NON-NLS-1$
	},

	_collapseExpandFolder: function(folderRow, fShow) 
	{
		var self = this;
		self._colexpState[folderRow.getAttribute('data-guid')] = !self._colexpState[folderRow.getAttribute('data-guid')]; //$NON-NLS-1$ //$NON-NLS-2$
		dojo.forEach(this._childMap[folderRow.getAttribute('data-guid')], function(childID) { //$NON-NLS-1$
			var childRow = this.getTr(childID); 
			childRow.style.display = (fShow == "true") ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
			if(childRow._rowType == FOLDERTYPE) { 
				if(childRow._expanded == "true") { //$NON-NLS-1$
					self._collapseExpandFolder(childRow, fShow);
					
				}
			}
				
		}, this);
	},

	_handleCheckBoxClick: function(args)
	{
		var checkedState = args.currentTarget.checked;

		//if we unchecked a report then make sure the folder is unchecked also
		if (checkedState == false)
			this._setRowCheckedState(args.currentTarget.parentNode.parentNode.folderID, false);

		this._updateActions();
	},
	_handleFolderCheckBoxClick: function(args)
	{
		var checkedState = args.currentTarget.checked;
		var folderID = args.currentTarget.parentNode.parentNode.getAttribute('data-guid'); //$NON-NLS-1$
		this._handleFolderCheck(folderID, checkedState);
		this._updateActions();
	},
	
	_handleFolderCheck: function(folderID, checkedState)
	{
		var childIDs = this._childMap[folderID];
		for (var i = 0; i < childIDs.length; i++)
		{
			var childID = childIDs[i];
			this._setRowCheckedState(childID, checkedState);
			if (this._childMap[childID] != null)   //Recurse child nodes
				this._handleFolderCheck(childID, checkedState);
		}
	},
	
	_getCheckboxFromTR: function(trNode)
	{
		if(trNode._rowType == "folder") { //$NON-NLS-1$
			return trNode.children[0].children[1];  //First child is the <td> second child of that is the input (checkbox);
		} else {
			return trNode.children[0].children[0];  //First child is the <td> first child of that is the input (checkbox);
		}
	},
	
	_isRowChecked: function(trNode)
	{
		return this._getCheckboxFromTR(trNode).checked;
	},
	
	_setRowCheckedState: function(rowID, checkedState)
	{
		var tr = this.getTr(rowID);
		if(!tr) return;
		var cb = this._getCheckboxFromTR(tr);
		cb.checked = checkedState;
	},
	
	_updateActions: function()
	{
		var buttonCounter = 0;
		var button = null;
		while((button = this.metanav._toolbar.getItem(buttonCounter++)) != null)
		{
			this._updateRequireSelection(button);
			if(this.shared) {
				if(button.args.requireCreate) {
					if (this.permissions.createPermission) {
						this._updateRequireSelection(button);
					} else {
						this.metanav._toolbar.disableButton(button);
					}
				}
				if(button.args.requireModify) {
					if (this.permissions.modifyPermission) {
						this._updateRequireSelection(button);
					} else {
						this.metanav._toolbar.disableButton(button);
					}
				}
				if(button.args.requireDelete) {
					if (this.permissions.deletePermission) {
						this._updateRequireSelection(button);
					} else {
						this.metanav._toolbar.disableButton(button);
					}
				}
			} 
		}
	},
	
	_updateRequireSelection: function(button) 
	{
		var rowsChecked = this._getCheckedCount() > 0;
		if (button.args.requiresSelection)
		{
			if (rowsChecked)
				this.metanav._toolbar.enableButton(button);
			else
				this.metanav._toolbar.disableButton(button);
		}
		
	},

	_deleteItems: function()
	{
		var messages = this._messages;
		var items = this._getCheckedItems(true);
		if (items.length <= 0)
			return;
			
		var viewItemIDs = [];
		var folderItemIDs = [];

		for (var i = 0; i < items.length; i++)
		{
			var item = items[i];
			if (item.rowType == VIEWTYPE)
				viewItemIDs.push(item.id);
			else if (item.rowType == FOLDERTYPE)
				folderItemIDs.push(item.id);
		}

		var confirmMsg = ""; //$NON-NLS-1$
		if (viewItemIDs.length > 0 && folderItemIDs.length > 0)
			confirmMsg = dojo.string.substitute(messages.confirmDelViewsAndFolders, [viewItemIDs.length, folderItemIDs.length]);
		else if (viewItemIDs.length > 0)
			confirmMsg = dojo.string.substitute(messages.confirmDelViews, [viewItemIDs.length]);
		else
			confirmMsg = dojo.string.substitute(messages.confirmDelFolders, [folderItemIDs.length]);
		
		if (!confirm(confirmMsg)) {
			return;
		}
		
		// check dirty view and confirm close it
		var viewUris = dojo.clone(viewItemIDs);
		for(var i = 0; i < folderItemIDs.length; i++) {
			this._addAllChildViewsForClose(folderItemIDs[i], viewUris);
		}				
		if(!this.diagramPage.deleteViews(viewUris)) {
			return;
		}

		this._deletedTypes = 0;
		//Delete the queries if any
		if (viewItemIDs.length > 0) 
		{
			this._deletedTypes++;
			var args = {
    			configURIs: viewItemIDs
    		};
			var responseHandler = new ServiceResponseHandler(this, "_viewsDeleted", "_remoteError"); //$NON-NLS-1$ //$NON-NLS-2$
			ViewClient.postDeleteConfigDescriptors(responseHandler, args);
		}
		
		if (folderItemIDs.length > 0) 
		{
			this._deletedTypes++;
			var folderArgs = {
				folderUUIDs: folderItemIDs
			};
			//Delete the folders
			var responseHandler = new ServiceResponseHandler(this, "_viewsDeleted", "_remoteError"); //$NON-NLS-1$ //$NON-NLS-2$
			ViewClient.postDeleteFolderDescriptors(responseHandler, folderArgs);
		}		
	},

	_moveItems: function()
	{
		var messages = this._messages;
		var items = this._getCheckedItems(true);
		if (items.length <= 0)
			return;
			
		var configURIs = [];
		var configNames = [];
		var folderUUIDs = [];
		var folderNames = [];

		for (var i = 0; i < items.length; i++)
		{
			var item = items[i];
			if (item.rowType == VIEWTYPE) 
			{
				configURIs.push(item.id); 
				configNames.push(item.name);
			}
			else if (item.rowType == FOLDERTYPE)
			{
				folderUUIDs.push(item.id); 
				folderNames.push(item.name);
			} 
		}
		
		var args = {
			folderUUIDs: folderUUIDs,
			folderNames: folderNames,
			configURIs: configURIs,
			configNames: configNames,
			shared: this.shared,
			permissions: this.permissions,
			
			parentUUID: null,

			okCallback: dojo.hitch(this,this._okDialogCallback),
			cancelCallback: dojo.hitch(this,this._cancelDialogCallback)
		};
		var moveView = new com.ibm.relm.explorer.web.ui.internal.view.MoveView(args);
		
		this._dialog = new jazz.ui.Dialog({
			contentNode: moveView.mainDiv,
			primaryTitle: messages.moveView,
			width: "300px", //$NON-NLS-1$
			isClosable: true
		});
		
		
	},
	_viewsDeleted: function(args)
	{
		this._deletedTypes--;
		if (this._deletedTypes <= 0)
			this._runNewView();
	},
	

	_newFolder: function() {
		var isShared = (this.shared == true) ? "true" : "false"; //$NON-NLS-1$ //$NON-NLS-2$
		window.location.href = this.editFolderAction + "&mode=create&folderType=view&shared=" + isShared; //$NON-NLS-1$
	},
	_newView: function() {
		//window.location.href = this.createViewAction;
		//dojo.publish("com.ibm.relm.explorer.web.CREATE_VIEW");
		com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard.openWizard(this.shared);
	},

	_createNewFolder: function(folder) {
		var isShared = (this.shared == true) ? "true" : "false"; //$NON-NLS-1$ //$NON-NLS-2$
		window.location.href = this.editFolderAction + "&mode=create&folderType=view&parentUUID=" + folder.folderUUID + /*"&processAreaUUID=" + folder.processAreaUUID +*/ "&shared=" + isShared; //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	_editView: function(r)
	{
    	window.location.href = "#action=com.ibm.relm.explorer.web.showEditor&viewUri="+r.name.value + "&viewName="+encodeURIComponent(r.name.label); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_editFolder: function(folder) {
		window.location.href = this.editFolderAction + "&mode=modify&folderType=view&folderUUID=" + folder.folderUUID; //$NON-NLS-1$
	},

	_filterDeletedFolder: function(deleted, root){
		if(deleted.parentUUID == root.folderUUID){
			root.children.folders = dojo.filter(root.children.folders, function(item){
		    	return item.name.value != deleted.name.value;
			});
		}
		else if(root.children.folders.length >0){
				var self = this;
				dojo.forEach(root.children.folders, function(entry,i){
    				entry = self._filterDeletedFolder(deleted,entry);
  				});
		}
		return root;
	},
	_deleteFolder: function(folder) {
		var messages = this._messages;
		if (!confirm(dojo.string.substitute(messages.confirmDelFolder, [com.ibm.relm.explorer.web.ui.internal.util.unescapeHtml(folder.name.label)]))) {
			return;
		}
		
		// check dirty views and confirm close them
		var viewUris = [];
		this._addAllChildViewsForClose(folder.folderUUID, viewUris);
		if(!this.diagramPage.deleteViews(viewUris)) {
			return;
		}
		var args = {
				folderUUID: folder.folderUUID
		};
		var responseHandler = new ServiceResponseHandler(
				this,
				"_folderDeleted", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		var rowNode = this.getTr(folder.folderUUID); 
		if(rowNode){
			this._pendingDeleteFolderNode = rowNode;
		}
//		find all of the child nodes
		this._pendingDeleteFolderChildrenNodes = new Array();
		this._addAllChildViewsToFolderDelete(folder.folderUUID);
		this._rootFolder = this._filterDeletedFolder(folder, this._rootFolder);
		ViewClient.postDeleteFolderDescriptor(responseHandler, null, args);
	},
	_addAllChildViewsToFolderDelete: function(uuid){
		var folderChildren = this._childMap[uuid];
		if(folderChildren){
			for(var i = 0; i < folderChildren.length; i++){
				var child = this.getTr(folderChildren[i]); 
				if(child){
					this._pendingDeleteFolderChildrenNodes.push(child);
					this._addAllChildViewsToFolderDelete(child.getAttribute('data-guid')); //$NON-NLS-1$
				}
			}
		}
	},
	_addAllChildViewsForClose: function(uuid, viewUris) {
		var folderChildren = this._childMap[uuid];
		if(folderChildren){
			for(var i = 0; i < folderChildren.length; i++){
				var child = this.getTr(folderChildren[i]); 
				if(child){
					if( child._rowType == "view") { //$NON-NLS-1$
						viewUris.push(child.getAttribute('data-guid')); //$NON-NLS-1$
					} else {
						this._addAllChildViewsForClose(child.getAttribute('data-guid'), viewUris); //$NON-NLS-1$
					}
				}
			}
		}
		
	},
	
	_folderDeleted: function() {
		if(this._pendingDeleteFolderNode && this._pendingDeleteFolderNode != null){
			this._table.tbody.removeChild(this._pendingDeleteFolderNode);
			this._pendingDeleteFolderNode = null;
		}
		if(this._pendingDeleteFolderChildrenNodes && this._pendingDeleteFolderChildrenNodes != null){
			for(var i = 0; i < this._pendingDeleteFolderChildrenNodes.length; i++){
				this._table.tbody.removeChild(this._pendingDeleteFolderChildrenNodes[i]);
			}
			this._pendingDeleteFolderChildrenNodes = null;
		}
		this._updateActions();
	},
	_filterDeletedView: function(deleted, root){
		if(deleted.parentUUID == root.folderUUID){
			root.children.views = dojo.filter(root.children.views, function(item){
		    	return item.name.value != deleted.name.value;
			});
		}
		else if(root.children.folders.length >0){
				var self = this;
				dojo.forEach(root.children.folders, function(entry,i){
    				entry = self._filterDeletedView(deleted,entry);
  				});
		}
		return root;
	},
	_deleteView: function(r) {
		var messages = this._messages;
		if (!confirm(dojo.string.substitute(messages.confirmDelView, [com.ibm.relm.explorer.web.ui.internal.util.unescapeHtml(r.name.label)]))) {
			return;
		}

		// check dirty view and confirm close it		
		if(!this.diagramPage.deleteView(r.name.value)) {
			return;
		}
		
		var args = {
				configURI: r.name.value
		};
		var responseHandler = new ServiceResponseHandler(
				this,
				"_viewDeleted", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		var rowNode = this.getTr(r.name.value); 
		if(rowNode){
			this._pendingDeleteViewNode = rowNode;
		}
		ViewClient.postDeleteConfigDescriptor(responseHandler, args);
		this._rootFolder = this._filterDeletedView(r,this._rootFolder);
	},
	_viewDeleted: function() {
		if(this._pendingDeleteViewNode && this._pendingDeleteViewNode != null){
			this._table.tbody.removeChild(this._pendingDeleteViewNode);
			this._pendingDeleteViewNode = null;
		}
		this._updateActions();
	},
	_moveView: function(view)
	{
		var messages = this._messages;
		var configURIs = [view.name.value];
		var configNames = [view.name.label];
		var args = {
				configURIs: configURIs,
				configNames: configNames,
				shared: this.shared,
				permissions: this.permissions,
				parentUUID: (this.permissions.createPermission && (view.parentUUID != null)) ? view.parentUUID : "", //$NON-NLS-1$
						okCallback: dojo.hitch(this,this._okDialogCallback),
						cancelCallback: dojo.hitch(this,this._cancelDialogCallback)
		};
		var moveView = new com.ibm.relm.explorer.web.ui.internal.view.MoveView(args);
		this._dialog = new jazz.ui.Dialog({
			contentNode: moveView.mainDiv,
			primaryTitle: messages.moveView,
			width: "400px", //$NON-NLS-1$
			isClosable: true
		});
	},
	_moveFolder: function(folder)
	{
		var messages = this._messages;
		var folderUUIDs = [folder.folderUUID];
		var folderNames = [folder.name.label];
		var args = {
				folderUUIDs:folderUUIDs,
				folderNames: folderNames,
				shared: this.shared,
				permissions: this.permissions,
				parentUUID: (this.permissions.createPermission && (folder.parentUUID != null)) ? folder.parentUUID : "", //$NON-NLS-1$
						okCallback: dojo.hitch(this,this._okDialogCallback),
						cancelCallback: dojo.hitch(this,this._cancelDialogCallback)
		};
		var moveView = new com.ibm.relm.explorer.web.ui.internal.view.MoveView(args);
		this._dialog = new jazz.ui.Dialog({
			contentNode: moveView.mainDiv,
			primaryTitle: messages.moveFolder,
			width: "300px", //$NON-NLS-1$
			isClosable: true
		});
	},
	
	_exportViews: function(){
		var items = this._getCheckedItems(false);
		if (items.length <= 0)
			return;
			
		var viewItemIDs = [];
		for (var i = 0; i < items.length; i++) {
			var item = items[i];
			if (item.rowType == VIEWTYPE)
				viewItemIDs.push(item.id);
		}

		if (viewItemIDs.length > 0)	{
			var url = com.ibm.relm.explorer.web.ui.configServiceUri + "?method=exportViews";//$NON-NLS-1$
			//
			var form = dojo.create("form", {"name": "exportViews", "action":url, "method":'post'}, this.domNode);//$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$//$NON-NLS-4$//$NON-NLS-5$//$NON-NLS-6$
			dojo.forEach(viewItemIDs, function(id){
				dojo.create("input", {"type":"hidden", "name":"configURIs", "value": id}, form);//$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$//$NON-NLS-4$//$NON-NLS-5$//$NON-NLS-6$
			});
			form.submit();
			this.domNode.removeChild(form);
		}
	},

	_doFilter: function(filter) {
		this._currentFilter = filter;
		this._isRelatedFilterState = true;
		// set a timeout to query with the new filter
		// need to ensure 0 is passed to _runView or setTimeout will pass some other value
		if (!this._runViewTimeout) {
			this._runViewTimeout = setTimeout(dojo.hitch(this,this._runNewViewForView,0,true),500);
		}
	},
	
	_okDialogCallback: function(args)
	{
		this._dialog.close();
		this._dialog.destroy();
		var needRefresh = false;
			
		if((args.targetShared && this.scope == "shared") || (!args.targetShared && this.scope == "personal")) { //$NON-NLS-1$ //$NON-NLS-2$
			// target is same scope  -  refresh the current view list only
			needRefresh = true;
		} else {
			// target is different scope  -  refresh the current if the operation is move, and refresh target view list when it is shown next
			needRefresh = args.isMove;
			// enable refresh flag for another scope view list
			this.diagramPage.setListDirty((args.targetShared)?"shared":"personal"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		if(needRefresh)	this._runNewView();
	},
	_cancelDialogCallback: function(args)
	{
		this._dialog.close();
		this._dialog.destroy();
	},


	_remoteError: function(error) {
		PlatformUI.getWorkbench().showMessage(error.message);
	},

	_getCheckedItems: function(excludeChildrenOfSelectedFolders)
	{
		var retVal = [];
		var body = this._table.tbody;
		var tableRows = body.children;
		for (var i = 0; i < tableRows.length; i++)
		{
			var row = tableRows[i];
			if (this._isRowChecked(row))
			{
				var selectedItem = {};
				selectedItem.rowType = row._rowType;
				selectedItem.id = row.getAttribute('data-guid'); //$NON-NLS-1$
				selectedItem.name = row._name;
				retVal.push(selectedItem);
				//If we want to exclude children of selected folders
				if (excludeChildrenOfSelectedFolders && row._rowType == FOLDERTYPE)
				{
					//skip all the subsequent rows until the next sibling
					var indent = row._indent;
					while ((i+1 < tableRows.length) && 
							(((tableRows[i+1]._rowType == FOLDERTYPE)? tableRows[i+1]._indent : tableRows[i+1]._indent - INDENT) > indent))
						i++;
				}
			}
		}
		
		return retVal;
	},
		
	_getCheckedCount: function()
	{
		var retVal = 0;
		var body = this._table.tbody;
		var tableRows = body.children;
		for (var i = 0; i < tableRows.length; i++)
		{
			var row = tableRows[i];
			if (this._isRowChecked(row))
				retVal++;
		}
		
		return retVal;
	},
	
	// tool-bar actions
	onReload: function() {
    	this._refreshContent();
    },
    
    onShown: function() {
		var title = this.shared ? this._messages.SharedViews : this._messages.PrivateViews;
		JazzUIWorkbench.setTitle(title);
		
    	if(this._refreshRequired) {
    		this._emptyTable();
    		this._refreshContent();
    		this._refreshRequired = false;
    	} else {
    		// just change selected tab
    		this.refreshTabs();
    	}
    },

    onResourceSelected: function(target){
    	this._previousSelectedViewUri = target._uri_;
		window.location.href = "#action=com.ibm.relm.explorer.web.showDiagram&viewUri="+target._uri_ + "&viewName="+encodeURIComponent(target._name_); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
    onEdit: function(r) {
    	window.location.href = "#action=com.ibm.relm.explorer.web.showEditor&viewUri="+target.name.value + "&viewName="+encodeURIComponent(target.name.label); //$NON-NLS-1$ //$NON-NLS-2$
    },
    
    onDelete: function(resource) {

    	var self = this;
    	jazz.client.xhrDelete({
            url: resource.name.value,
            handle: function(){
    			JazzUIWorkbench.hideMessageArea();	            	
            },
            load: function(data, ioArgs){
                // Render resource list 
        		self._refreshContent();
            }
            //,
			//error: errorHandler
        });

    }

});
})();

