/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.DiagramView"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.HorizontalSlider"); //$NON-NLS-1$
dojo.require("dijit.form.HorizontalRuleLabels"); //$NON-NLS-1$
dojo.require("dijit.form.HorizontalRule"); //$NON-NLS-1$
dojo.require("dijit.layout.AccordionContainer"); //$NON-NLS-1$
dojo.require("dijit.layout.StackContainer"); //$NON-NLS-1$
dojo.require("dijit.layout.TabContainer"); //$NON-NLS-1$
dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
dojo.require("dijit.layout.BorderContainer"); //$NON-NLS-1$
dojo.require("dojox.gfx.utils"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.Workbench"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox");  //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require('jazz.app.ua.PageHoverHelp'); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.client.session.Session"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.DiagramViewInput");  //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.Layout"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.Table"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.ConfigTextEditor"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.ConfigFormEditor"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.PropertiesPane"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.PagePropertiesPane"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.Palette"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.queryparams.SystemParameterUtil"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ColorUtils"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.SetParametersTable"); //$NON-NLS-1$


dojo.require("com.ibm.relm.explorer.web.ui.internal.reports.ReportWizard"); //$NON-NLS-1$
dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$

dojo.require("rmps.ui.SidebarContainer"); //$NON-NLS-1$
dojo.require("rmps.ui.Sidebar"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "DiagramViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("rmps.ui.editor", "PageHelperMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require("jazz.core.loader"); //$NON-NLS-1$

(function(){

var paramUtil = com.ibm.relm.explorer.web.explorer.queryparams.SystemParameterUtil;
var util = com.ibm.relm.explorer.web.ui.internal.util;
var messages = dojo.i18n.getLocalization("rmps.ui.editor", "PageHelperMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var showPalette = false;

var JazzUIWorkbench = net.jazz.ajax.ui.PlatformUI.getWorkbench();
var HIDDEN_CLASS_NAME = "hiddenDescArea"; //$NON-NLS-1$

function isEmptyObject(obj){
	for(var o in obj){
		return false;
	}
	return true;
}
/*
 * DiagramView is a toplevel widget of view hierarchy.
 * DiagramView 
 *    -(layout)-> Layout 
 *                 -(viewer)-> DiagramWidget 
 *                               -(diagramLayer)-> DiagramLayer 
 *                                                   -(viewer)-> DiagramEditRoot 
 *                                                                -(editor)-> DiagramEditor
 */
var _Layout = "layout";//$NON-NLS-1$ 
var _DiagramWidget = _Layout + ".viewer";//$NON-NLS-1$ 
var _DiagramLayer = _DiagramWidget + ".diagramLayer";//$NON-NLS-1$ 
var _DiagramEditRoot = _DiagramLayer + ".viewer";//$NON-NLS-1$ 
var _DiagramEditor = _DiagramEditRoot + ".editor";//$NON-NLS-1$ 

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.DiagramView", //$NON-NLS-1$
	[ dijit._Widget, dijit._Templated, dijit._Container ],
{
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/templates/DiagramView.html"), //$NON-NLS-1$ //$NON-NLS-2$
	addButtonIcon: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/templates/add.gif"), //$NON-NLS-1$ //$NON-NLS-2$
	_collapsedIconSrc: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/grey-twistie-closed.png").toString(), //$NON-NLS-1$ //$NON-NLS-2$
	_expandedIconSrc: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/grey-twistie-open.png").toString(), //$NON-NLS-1$ //$NON-NLS-2$
	
	title: "", //$NON-NLS-1$
	page: null,
	permissions: null,
	
	_dirty: false,
	
	_sideBar: null,
	_parameterPane: null,
	_palettePane: null,
	_propertiesPane: null,
	_pagePropertiesPane: null,
	
	_keptParams: null,
	_keptHash: null,

	_editorInput: null,
//	_view: null,
	
	_csPageHelpWidgets: null,

	attributeMap: {
		title: { node: "titleNode", type: "innerHTML" } //$NON-NLS-1$ //$NON-NLS-2$
	},

	constructor: function() {
		this._csPageHelpWidgets= [];
		this._keptParams = [];
		
	},

	postMixInProperties: function() {
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "DiagramViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		if(!this.title)
			this.title = this._messages.defaultTitle;
		
		// switch reporting function
		var queryString = dojo.doc.location.search;
		if(queryString.length > 1){
			queryString = queryString.substring(1);
			if(dojo.queryToObject(queryString)["useRPE"] === "true"){ //$NON-NLS-1$ //$NON-NLS-2$
				this._useRPE = true; 
			}
		}
	},
	
	postCreate: function(){
		this.inherited(arguments);
		
		var queryString = dojo.doc.location.search;
		if(queryString.length > 1){
			queryString = queryString.substring(1);
			if(dojo.queryToObject(queryString)["editForm"] === "true"){ //$NON-NLS-1$ //$NON-NLS-2$){
				this.formPage = new com.ibm.relm.explorer.web.ui.internal.editor.ConfigFormEditor({title: this._messages.detail});
				this.formPage.setPermissions(this.permissions);
				this.formPage.setMessageArea(this.messageArea); //
				this.connect(this.formPage, "onClose", this.onFormPageClosed); //$NON-NLS-1$
				this.connect(this.formPage, "onSwitch", this.onSwitchToSource); //$NON-NLS-1$
				this.connect(this.formPage, "onSaveCompleted", this.onFormPageSaveCompleted); //$NON-NLS-1$
				this.stackContainer.addChild(this.formPage);				
			}
			if(dojo.queryToObject(queryString)["editSrc"] === "true"){ //$NON-NLS-1$ //$NON-NLS-2$
				this.sourcePage = new com.ibm.relm.explorer.web.ui.internal.editor.ConfigTextEditor({title: this._messages.source});
				this.connect(this.sourcePage, "onClose", this.onSourcePageClosed); //$NON-NLS-1$
				this.connect(this.sourcePage, "onSwitch", this.onSwitchToForm); //$NON-NLS-1$
				this.connect(this.sourcePage, "onSaveCompleted", this.onSourcePageSaveCompleted); //$NON-NLS-1$				
				this.stackContainer.addChild(this.sourcePage);
			}
		}
		
		// enable/disable edit button
		if(!this._canEdit()) {
			this.editButton.domNode.style.display = "none"; //$NON-NLS-1$
		}
		if(util.checkURLOption("printButton")){//$NON-NLS-1$
			this.printButton.domNode.style.display = ""; //$NON-NLS-1$
		}
		this.refreshDiagram();	

		this.connect(this.stackContainer, "selectChild", this._onSelectChild); //$NON-NLS-1$
		
		this.connect(this.descriptionCollapseButton, "onclick", this._onDescripctionCollapseButtonClick); //$NON-NLS-1$
		this.connect(this.descHeaderText, "onclick", this._onDescripctionCollapseButtonClick); //$NON-NLS-1$
		this.connect(this.descHeaderText, "onmouseover", function(e) { //$NON-NLS-1$
			dojo.toggleClass(e.target, "hover", true); //$NON-NLS-1$
		}); 
		this.connect(this.descHeaderText, "onmouseout", function(e) {  //$NON-NLS-1$
			dojo.toggleClass(e.target, "hover", false); //$NON-NLS-1$
		});
		
		this.showEditorTab(this.useForm);

	   	this._editorInput = new com.ibm.relm.explorer.web.ui.internal.view.DiagramViewInput({id: this.viewUri.split("/").pop(), resourceUri: this.viewUri}); //$NON-NLS-1$
	   	this._editorInput.editor = this;

	},

	_createSidebarContent: function(){
		if(this._sideBar){
			return this._sideBar;
		}
		
		this._sideBar = new dijit.layout.AccordionContainer({
			// (#89590) Workaround for that rmps.ui.SidebarContainerSash doesn't update _sidebarWidth in _dragResize
			
			// (#92473) Layout of sidebar (rmps.ui.SidebarContainer) happens on view creation. This triggers window.onresize(), 
			// which is monitored by opened views. When an invisible view (hidden in backend) gets this event, 
			// this.domNode.parentNode.offsetWidth is zero. Then, width of contents of sidebar is set to zero in the result of the workaround for #89590.
			// Since the workaround is for the problem that happens during or after dragging sash of sidebar, 
			// there is no need for backend views to react to this.  
			resize: function(size){
				if(size && size.w && this.domNode.parentNode.offsetWidth > 0){
					size.w = this.domNode.parentNode.offsetWidth;
				}
				this.inherited("resize", arguments); //$NON-NLS-1$
			}
		});

		// Page Properties Pane
		this._pagePropertiesPane = new dijit.layout.ContentPane({
            title: this._messages.pagePropertiesPaneTitle,
            content: this._messages.noComponents
        });
		this._pagePropertiesContent = new com.ibm.relm.explorer.web.ui.internal.view.edit.PagePropertiesPane({
            diagramView: this
		});
		this._pagePropertiesPane.set("content", this._pagePropertiesContent);//$NON-NLS-1$
		this._sideBar.addChild(this._pagePropertiesPane);

		// Properties Pane
		this._propertiesPane = new dijit.layout.ContentPane({
            title: this._messages.propertiesPaneTitle,
            content: this._messages.noComponents
        });
		this._propertiesContent = new com.ibm.relm.explorer.web.ui.internal.view.edit.PropertiesPane({
            diagramView: this
		});
		this._setContentHandler = this.connect(this._propertiesContent, "setContents", function(node, container){ //$NON-NLS-1$
			if(node || container) {
				this._sideBar.selectChild(this._propertiesPane);
			}else{
				this._sideBar.selectChild(this._pagePropertiesPane);
			}
		});
		this._propertiesPane.set("content", this._propertiesContent);//$NON-NLS-1$
		this._sideBar.addChild(this._propertiesPane);

		// Palette
		if(showPalette){
			this._palettePane = new dijit.layout.ContentPane({
	            title: this._messages.paletteTitle,
	            content: this._messages.noComponents
	        });
			this._palette = new com.ibm.relm.explorer.web.ui.internal.view.edit.Palette({});
			this._palettePane.set("content", this._palette);//$NON-NLS-1$
			this._sideBar.addChild(this._palettePane);
		}		
	},

	_createContextSensitiveHelp: function() {
		if(this._sideBar == null || this._sideBar._csHelpAdded == true) {
			return;
		}
		var fHelp1 = false;
		var fHelp2 = false;
		if(this._pagePropertiesPane._buttonWidget) {
			this._pagePropertiesPane._buttonWidget.titleNode.appendChild(this._createCSHWidget("com.ibm.relm.explorer.web.section_Page_Props001")); //$NON-NLS-1$
			fHelp1 = true;
		}
		if(this._propertiesPane._buttonWidget){
			this._propertiesPane._buttonWidget.titleNode.appendChild(this._createCSHWidget("com.ibm.relm.explorer.web.section_Props001")); //$NON-NLS-1$
			fHelp2 = true;
		}
		this._sideBar._csHelpAdded = fHelp1 && fHelp2;
	},

	_createCSHWidget: function(uaKey) {
		var parms = {};
		parms.uaKey = uaKey;
		var pageHelp = new jazz.app.ua.PageHoverHelp(parms);
		this._csPageHelpWidgets.push(pageHelp);
		return  pageHelp.domNode;
	},


	_createParameterPane: function(){
		if(!this._parameterPaneTable || !this._parameterPaneTable.domNode){
			var table = new com.ibm.relm.explorer.web.ui.internal.view.common.SetParametersTable();
			this._parameterPaneTable = table;
		}
		return this._parameterPaneTable.domNode;
	},
	
	_updateParameterPane: function(){
		var config = this._getConfig();
		if(config){
			var parameters = [];
			for(var name in config.params){
				var param = config.params[name];
				var value = param["value"]; //$NON-NLS-1$
				var type = param["type"]; //$NON-NLS-1$
				if(type === undefined) {
					// maybe URL parameter
					continue;
				}
				var isSystemParam = type.substr(0, 7) == "system:"; //$NON-NLS-1$
				if(isSystemParam) {
					value = paramUtil.getValues(type.substr(7)).displayValue;
				}
				parameters.push({
					name : name, 
					value: value,
					type: type,
					description: param["description"],  //$NON-NLS-1$
					mandatory: param["mandatory"],//$NON-NLS-1$
					readonly: isSystemParam
				});
			};
			this._parameterPaneTable.setParameters(parameters);
		}		
	},
	
	destroy: function(){
		if(this.layout)
			this.layout.destroy();
		this._cleanSidebar();
		if(this._parameterPane)
			this._parameterPane.destroy();
		if(this._palettePane)
			this._palettePane.destroy();
		if (this.navigateAwayHandle) {
			JazzUIWorkbench.unregisterBodyClickHandler(this.navigateAwayHandle);
			this.navigateAwayHandle = null;
		}
		if (this.onBeforeUnloadHandle) {
			JazzUIWorkbench.unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
			this.onBeforeUnloadHandle = null;
		}	
		dojo.forEach(this._csPageHelpWidgets, function(w) { w.destroy; });
		if (this._editorInput)
			delete this._editorInput;
		this.inherited(arguments);
	},
	
	refreshDiagram: function(noReload){
		if(dojo.doc.location.hash != this._keptHash){
			this._keptHash = null;
			this._keptParams = []; // clear
		}
		var currentPage = this.stackContainer.selectedChildWidget; 
		if((!this.sourcePage || currentPage != this.sourcePage) && (!this.formPage || currentPage != this.formPage)){
			var doFocusOn = true; 
			if(!this.layout){
				this.layout = new com.ibm.relm.explorer.web.ui.internal.view.Layout({ viewUri: this.viewUri , diagramView: this});
				this.layout.startup();
				this.layout.layout();
				if(this._palette){
					this._palette.setEditorProvider(this);
				}
				if(this.formPage){
					this.formPage.setDiagramView(this);
				}
				var diagramEditor = this._getDiagramEditor();
				if(dojo.isFunction(diagramEditor.setMessageArea)){
					diagramEditor.setMessageArea(this.messageArea);	
				}
				this.sidebarContainer.setContent(this.layout, true);
				this.sidebarContainer.viewer = this.layout;
				this.connect(this._getDiagramLayer(), "onConfigLoaded", this._onConfigLoaded); //$NON-NLS-1$
			} else if(!noReload) {
				// call DiagramEditRoot.loadDiagram
				this._getDiagramEditRoot().loadDiagram(this.viewUri); 
			} else {
				doFocusOn = false;
			}
			if(doFocusOn){
				var diagramEditor = this._getDiagramEditor();
				if(diagramEditor){
					var hash = dojo.doc.location.hash;
					if(hash && hash.length > 1){
						hash = encodeURI(hash);
						var params = dojo.queryToObject(hash.substring(1));
						if(params.focusOn || params.focusOnText){
							this._prevSearchText = params.focusOnText;
							if(this._resourceLoadedHandler) this.disconnect(this._resourceLoadedHandler);
							this._resourceLoadedHandler = this.connect(diagramEditor, "onResourceLoaded", dojo.hitch(this, function(){//$NON-NLS-1$
								this._resourceLoaded({focusOn: params.focusOn, focusOnText: params.focusOnText});
							}));
						}
					}
				}
			}
		}
	},

	refreshDiagramLocal: function(){
		var source = this._getConfig();
		this._getDiagramEditRoot().reloadLocal(source);
	},
	
	showFormEditor: function(){
		this.openEditorFromView = true;
		this._onEdit();
	},
	
	_setDescription: function(description){
       	dojo.removeClass(this.extraDescriptionArea, HIDDEN_CLASS_NAME);
       	this.descExplanation.innerHTML = util.escapeHtml(description);
		this.page.resizeView(this);
 	},

	_onDescripctionCollapseButtonClick: function(e){
		dojo.stopEvent(e);
		if (dojo.hasClass(this.descExplanationDiv, HIDDEN_CLASS_NAME)) { 
			this.descCollapseImage.src = this._expandedIconSrc;
		} else {
			this.descCollapseImage.src = this._collapsedIconSrc;
		}
		dojo.toggleClass(this.descExplanationDiv, HIDDEN_CLASS_NAME);
		this.page.resizeView(this);
	},
	
	_resourceLoaded: function(params){
		this.disconnect(this._resourceLoadedHandler);
		this._resourceLoadedHandler = null;

		if(params.focusOn || params.focusOnText){
			var editor = this._getDiagramEditor();
			var allResourceNodes = editor.getAllResourceNodes();
			var foundNode = null;
			if(params.focusOn){
				for(var i =0; i < allResourceNodes.length; i++){
					var node = allResourceNodes[i];
					if(node.uri === params.focusOn){
						foundNode = node;
						break;
					}
				}
			}
			if(!foundNode && params.focusOnText){
				for(var i =0; i < allResourceNodes.length; i++){
					var node = allResourceNodes[i];
					if(dojo.isFunction(node.findText) && node.findText(params.focusOnText).length > 0){
						foundNode = node;
						break;
					}
				}
			}
			if(foundNode){
				this._panToNode(foundNode, editor);
			}
		}
	},
	
	_onConfigLoaded: function(){
		this.onConfigUpdated();
		// eval parameters
		var config = this._getDiagramConfig();
		var params = config.params;
		var isParamExist = params && !isEmptyObject(params); 
		if(isParamExist){
			if(!this._editMode){
				var needReload = false;
				dojo.forEach(this._keptParams, function(kp){
					var name = kp.name;
					if(params[name]){
						if(params[name].value != kp.value){
							params[name].value = kp.value;
							needReload = true;
						}
					}
				});
				if(this._checkUserGivenParamRequired(params)) {
					this._onSetParameters();
				}else if(needReload){
					setTimeout(dojo.hitch(this, this.refreshDiagramLocal), 0); // avoid recursive 
				}
			}
		}
		this.setParamButton.set('enabled', isParamExist);//$NON-NLS-1$
		// update edit button
		this.editButton.domNode.style.display = this._editMode || !this._canEdit() ? "none" : "";//$NON-NLS-1$//$NON-NLS-2$
		this.onConfigLoaded();
		this._editorInput._viewConfigLoaded(config);
	},
	
	onConfigUpdated: function(){
		// update title and description
		var config = this._getDiagramConfig();
		var diagramName = config.diagramName;
		this.titleNode.innerHTML = util.escapeHtml(diagramName);
		this._setDescription(config.description);
		JazzUIWorkbench.setTitle(diagramName);
		this._editorInput._viewConfigUpdated(config);
	},
	
	onConfigLoaded: function(){
		// for listeners
		this.page.pageHelper.openEditor(this);
	},
	
	_checkUserGivenParamRequired : function(params) {
		for(var name in params) {
			var param = params[name];
			if(param["mandatory"] && (!param["value"] || param["value"] == "")) { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
				return true;
			}
		}
		return false;
	},
	
	_getConfig: function(){
		var config = null;
		if(this.formPage){
			config = this.formPage.getConfig();
		}
		if(!config){
			config = this._getDiagramConfig();
		}
		return config;
	},
	
	_getDiagramWidget: function(){
		return dojo.getObject(_DiagramWidget, false, this);
	},
	
	_getDiagramLayer: function(){
		return dojo.getObject(_DiagramLayer, false, this);
	},
	
	_getDiagramEditRoot: function(){
		return dojo.getObject(_DiagramEditRoot, false, this);
	},
	
	_getDiagramEditor: function(){
		return dojo.getObject(_DiagramEditor, false, this);
	},
	
	// for public access
	getDiagramEditor: function(){
		return this._getDiagramEditor();
	},
	
	_getDiagramConfig: function(){
		var diagramEditor = this._getDiagramEditor();
		if(diagramEditor){
			return diagramEditor.getConfig();
		}
		return null;
	},
	
	_onReload: function(ev){
		var editor = this._getDiagramEditor();
		if(editor && editor._clearCachedResult){
			editor._clearCachedResult();
		}
		this.refreshDiagram();
	},
	
	_onSelectChild: function(){
		var selectedTab = this.stackContainer.selectedChildWidget;
		// check if switch from source but source page is dirty state
		if(this.sourcePage && selectedTab != this.sourcePage && this.selectedTab == this.sourcePage && this.sourcePage.isDirty()){
			if (!confirm(this._messages.navigateAway + "\n\n" + this._messages.unsavedChanges + "\n\n" + this._messages.okOrCancel)) { //$NON-NLS-1$ //$NON-NLS-2$
				this.stackContainer.selectChild(this.sourcePage);
				return;
			}
			this.sourcePage.clearContent();
		} 
		// 
		if(selectedTab == this.sourcePage){
			this.onSwitchToSource();
		}else if(selectedTab == this.formPage){
			this.onSwitchToForm();
		}else if(selectedTab == this.diagramPage){
			this.onSwitchToDesign();
		}
		// keep the current page
		this.selectedTab = this.stackContainer.selectedChildWidget;
	},
		
	_onEdit: function(){
		this.showEditorTab(true);
		this._createContextSensitiveHelp();
	},
	
	_onFormEdit: function(){
		if(!this.formPage){
			return;
		}
		//this.stackContainer.selectChild(this.formPage);
		var config = this._getDiagramConfig();
		if(config){
			// config has been loaded already by design page
			// reuse it
			this.formPage.setConfig(config);
			return;
		}
		JazzUIWorkbench.showMessage(this._messages.loading);
		var self = this;
		jazz.client.xhrGet({
			url: this.viewUri,
			preventCache: true,
			load: function(response, ioargs){
				JazzUIWorkbench.hideMessageArea();
				// load configuration
				var config = new com.ibm.relm.explorer.web.ui.internal.view.loader.Config();
				config.viewUri = self.viewUri;
				config.load(response, []);
				self.formPage.setConfig(config);
				//self.stackContainer.selectChild(self.formPage);
			},
			error: function(response, ioargs){
				JazzUIWorkbench.hideMessageArea();
				console.error(response.message);
		    	var message = com.ibm.relm.explorer.web.ui.internal.util.getXhrErrorMessage(response, ioargs);
		    	JazzUIWorkbench.showMessage(message);
        		response.responseText = null; // don't show the message in error dialog
			},
			headers: {"Accept": "text/json"}, //$NON-NLS-1$ //$NON-NLS-2$
			handleAs: "json" //$NON-NLS-1$ 
		});
	},
	
	_onSaveAndClose: function(ev){
		this._onSaveCore(true);
	},
	
	_onSave: function(ev){
		this._onSaveCore(false);
	},
	
	_onSaveCore: function(closeOnSave){
		this._keptParams = []; // clear
		
		this._clearDirty();
		var selectedTab = this.stackContainer.selectedChildWidget;
		if(selectedTab == this.sourcePage){
			this.sourcePage.save();
		}else if(selectedTab == this.formPage){
			this.formPage.save();			
		}else{
			this._doSave(closeOnSave);
		}
	},
	
	_doSave: function(closeOnSave){
		// put save request to server
		JazzUIWorkbench.showMessage(this._messages.saving);
		var config = this._getDiagramConfig();
		var self = this;
		jazz.client.xhrPut({
			url: config.viewUri,
			headers: {
				"Content-Type": "text/json"  //$NON-NLS-1$ //$NON-NLS-2$
			},
			putData: this.getConfigForSave(config),
			handle: function() {
				JazzUIWorkbench.hideMessageArea();
			},
			load: function() {
				self._onSaveCompleted(closeOnSave);
			},
			error: function(response, ioargs) {
				console.error(response.message);
		    	var message = com.ibm.relm.explorer.web.ui.internal.util.getXhrErrorMessage(response, ioargs);
		    	
		    	if(message.summary) { //$NON-NLS-1$
		    		var index = message.summary.indexOf(':'); //$NON-NLS-1$
		    		var msg = (index >= 0) ? message.summary.substring(index + 1) : message.summary;
		    		alert(msg );
		    		return;
		    	}
		    	self.messageArea.showMessage(message);		
		    }
		});
	},

	getConfigForSave:function(config){
		// remove system parameter values in saved configuration
		var configClone = dojo.clone(config);
		var params = configClone.params;
		for(var name in params) {

			var param = params[name];
			var type = param.type;
			if(type && type.indexOf("system:") == 0) { //$NON-NLS-1$
				param.value = ""; //$NON-NLS-1$
			}
		}
		return dojo.toJson(configClone);
		
	},
	
	_onCancel: function(ev){
		var isDirty = this._isDirty();
		if(isDirty && !confirm(dojo.string.substitute(messages.confirmCloseIfDirty, [this._getConfig().diagramName]))) {
			return;
		}
		var reloaded = this.showEditorTab(false);
		this.stackContainer.selectChild(this.diagramPage);
		if(this.formPage){
			this.formPage.cancelEdit();
		}
		if(isDirty){
			this._clearDirty();
			this.updateDirty();
			this.refreshDiagram(reloaded);
		}
	},
	
	_isDirty: function(){
		if(!this._editMode){
			return false;
		}
		if(this.formPage && this.formPage.isDirty()){
			return true;
		}
		var editor = this._getDiagramEditor();
		if(editor){
			var commandProcessor = editor.getCommandStack();
			if(commandProcessor.isDirty()){
				return true;
			}
		}
		return this._dirty;
	},
	
	isDirty: function() {
		return this._isDirty();
	},
	
	updateDirty: function() {
		this._dirty = this._isDirty();
		com.ibm.relm.explorer.web.ui.page.DiagramPageHelper.updateDirtyStatus(this.getEditorInput().getPageId());
		this.dirtyStateChanged(this._dirty);
		
	},
	
	dirtyStateChanged: function(isDirty) {
		// handler is connected
	},
	
	setDirty: function(dirty) {
		this._dirty = dirty;
		this.updateDirty();
	},
	
	_clearDirty: function() {
		this._dirty = false;
		var editor = this._getDiagramEditor();
		if(editor){
			var commandProcessor = editor.getCommandStack();
			commandProcessor.clear();
		}

	},
	
	_onSetParameters: function(ev){
		this._createParameterPane();
		this._updateParameterPane();
		var self = this;
		var table = this._parameterPaneTable;
		this._paramsDialog = new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
			primaryTitle: this._messages.setParameters,
			headerContent: {
				mainMessage: this._messages.paramDialogTitle,
				mainHtmlMessage: this._messages.paramDialogText
			},
			dialogContent: table,
			width: "570px", //$NON-NLS-1$
			isClosable: true,
			validate: function(values, callback) {
				// check if mandatory parameter is set or not
				if(!this._checkParams()){
	 				alert(self._messages.cancelMessage); //$NON-NLS-1$
	 				return;
				}
				// all parameter is set correctly
				callback();					
			},
			onOK: dojo.hitch(this, function(){
  				var config = this._getConfig();
  				dojo.forEach(table.parameters, function(p){
  	  				config.params[p.name].value = p.value;
  				});
  				if(!this._editMode){
  					this._keptParams = table.parameters;
  					this._keptHash = dojo.doc.location.hash; 
  				}
  				table.setParameters(null); // clear
 				this.refreshDiagramLocal();	
 			}),
			_checkParams: function(){
				// check if mandatory parameter is set or not
				return dojo.every(table.parameters, function(p){
					return (!p.mandatory) || p.value;
				});
			}
		});
	},
	
	_onPrint: function(ev){
		var scale = this._getDiagramLayer().getScale();
		window.open(this.viewUri + "?relm.printView=true&relm.ajaxmodule=true&relm.hideToolbar=true&relm.zoomLevel=" + scale*100);//$NON-NLS-1$
	},
	
	_onReport: function(ev){
		var self = this;
		// get all named queries used in this view
		var viewUri = this.viewUri;
		var viewId = viewUri.split("/").pop(); //$NON-NLS-1$
		var editor = this._getDiagramEditor();
		var allContainers = editor.getContainerSet();
		var queries = dojo.filter(allContainers.map(function(w){
			var containerNode = w._domNode;
			var containerId = containerNode ? containerNode.getAttribute("id") : null;  //$NON-NLS-1$
			if(containerId && dojo.isFunction(w.getQuery)){
				var containerName = containerNode.getAttribute("name"); //$NON-NLS-1$
				var query = w.getQuery();
				if(query && query.sparql){
					return dojo.mixin({
						containerId: containerId,
						containerName: containerName
					}, query);
				}
			}
			return null;
		}), function(q){
			return q;
		});

		// open wizard
		var wizard = new com.ibm.relm.explorer.web.ui.internal.reports.ReportWizard({
			_selectedReport: this._selectedReport,
			_reportParameters: this._reportParameters,
			primaryTitle: this._messages.printView,
			viewId: viewId, 
			queriesInView: queries, 
			customProcessFinish: function(){
				if(!self._useRPE){
					// report UUID
					var reportResultURL = "#action=com.ibm.team.reports.viewReport&reportUUID=" + this._selectedReport.reportUUID; //$NON-NLS-1$
					
					// parameters
					dojo.forEach(this._reportParameters, function(param){
						reportResultURL += "&parameterName=" + encodeURIComponent(param.name) + "&parameterValue=" + encodeURIComponent(param.queryUrl || param.value); //$NON-NLS-1$ //$NON-NLS-2$
					});
					// avoid problem described in WI89673
					reportResultURL += "&parameterName=_dummy_&parameterValue=_dummy_";//$NON-NLS-1$
					
					// open report view
					window.location.href = reportResultURL;
				}else{
					var publishServiceUri = net.jazz.ajax._contextRoot + "/relmui/publish"; //$NON-NLS-1$
					var queryUrls = dojo.map(this._reportParameters, function(p){
						return p.queryUrl;
					});
					var queryString = "?queryEndpoints=" + encodeURIComponent(dojo.toJson(queryUrls)) + "&reportID=" + encodeURIComponent(this._selectedReport.reportId); //$NON-NLS-1$ //$NON-NLS-2$
					window.open(publishServiceUri + queryString);
				}
				self._reportParameters = this._reportParameters; // keep to reuse.
				self._selectedReport = this._selectedReport; // keep to reuse.
			}
		});
		wizard.startup();
	},
	
	_findDialog: null,
	_prevSearchText: null,
	_onFind: function(ev){
		if(!this._findDialog){
			// Create Dialog
			var self = this;
			var editor = this._getDiagramEditor();
			var content = dojo.create("div", {style:"margin: 10px;"}); //$NON-NLS-1$ //$NON-NLS-2$
			var textBox = dojo.create("input", {name:"findText", style:"width: 100%"}, content); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			var div = dojo.create("div", {style:"text-align: right; white-space: nowrap; padding: 5px 0;"}, content); //$NON-NLS-1$ //$NON-NLS-2$
			var messageArea = dojo.create("span", {style:"float:left;"}, div); //$NON-NLS-1$ //$NON-NLS-2$
			var findButton = dojo.create("input", {type:"button", value:this._messages.find}, div); //$NON-NLS-1$ //$NON-NLS-2$ 
			var closeButton = dojo.create("input", {type:"button", value:this._messages.close}, div); //$NON-NLS-1$ //$NON-NLS-2$ 
			var dialog = this._findDialog = new jazz.ui.Dialog({
				primaryTitle: this._messages.findTextTitle, 
				contentNode:content, 
				modal:false, 
				closable: false, 
				width: "400px" //$NON-NLS-1$
			});
			dijit.focus(textBox);
			if(this._prevSearchText){
				textBox.value = this._prevSearchText;
			}
			// Cache all resource nodes
			var allResourceNodes = editor.getAllResourceNodes();
			
			// Event handlers for the dialog
			dialog.connect(closeButton, "onclick", function(){  //$NON-NLS-1$
				dialog.close();
			});
			var searchText = null;
			var foundResourceNode = [];
			var index = 0;

			// Nodes get stale if they are reloaded while dialog is open.
			this.subscribe("com.ibm.relm.explorer.web.VIEW_LAYOUT_COMPLETED", dojo.hitch(this, function(message) { //$NON-NLS-1$
				editor = this._getDiagramEditor();
				if (message && message == editor) {
					allResourceNodes = editor.getAllResourceNodes();
					searchText = null;
				}
			}));

			var findFunction = function(){
				messageArea.innerHTML = ""; //$NON-NLS-1$
				if(!textBox.value) return;
				if(textBox.value != searchText){
					// first search
					searchText = textBox.value;
					foundResourceNode = [];
					index = 0;
					if(searchText){
						foundResourceNode = dojo.filter(allResourceNodes, function(node){
							return dojo.isFunction(node.findText) && node.findText(searchText).length > 0;
						});
					}
				}else{
					// search next
					if(++index >= foundResourceNode.length){
						index = 0;
					}
				}
				if(foundResourceNode.length == 0){
					messageArea.innerHTML = self._messages.notFound;
					return;
				}
				found = foundResourceNode[index];
				self._panToNode(found, editor);
				dijit.focus(textBox);
			};
			dialog.connect(textBox, "onkeypress", function(ev){ //$NON-NLS-1$
				if(ev.keyCode == dojo.keys.ENTER){
					findFunction();
				}
			});
			dialog.connect(findButton, "onclick", findFunction); //$NON-NLS-1$
			dialog.connect(dialog, "close", function(){ //$NON-NLS-1$
				dialog.destroy();
				self._findDialog = null;
			});
		}
	},
	
	_panToNode: function(node, editor){
		editor.removeFocus();
		editor.setFocus(node);
		var viewport = this._getDiagramWidget().viewport;
		var surfaceWidth = viewport.surface.rawNode.attributes["width"].value;//$NON-NLS-1$
		var surfaceHeight = viewport.surface.rawNode.attributes["height"].value;//$NON-NLS-1$
		var nodeOffset = this._getAbsolutePosition(node.group, 0, 0);
		var panX = nodeOffset.x;
		var panY = nodeOffset.y;
		if(viewport.contents.matrix){
			panX *= viewport.contents.matrix.xx;
			panY *= viewport.contents.matrix.yy;
		}
		if(panX > 0 && panX < surfaceWidth){
			panX = 0;
		}else{
			panX = surfaceWidth/2 - panX;
		}
		if(panY > 0 && panY < surfaceHeight){
			panY = 0;
		}else{
			panY = surfaceHeight/2 - panY;
		}
		viewport.pan(panX, panY);
	},
	
	_getAbsolutePosition: function(node, x, y){
		var parentPos;
		if(node.parent){
			parentPos = this._getAbsolutePosition(node.parent, x, y);
		}else{
			parentPos = {x: 0, y: 0};
		}
		if(node.matrix){
			return {x: (parentPos.x + node.matrix.dx/node.matrix.xx), y: (parentPos.y + node.matrix.dy/node.matrix.yy)};
		}
		return {x: parentPos.x, y: parentPos.y};
	},
	
	_onSliderChanged: function(newValue){
		this._getDiagramEditor().group.setTransform([dojox.gfx.matrix.scaleAt(newValue/100, 0, 0)]);
	},
	
	_onSaveCompleted: function(/* boolean */ exitEditMode){
		this.updateDirty();
		if(exitEditMode){
			// exit edit mode
			var reloaded = this.showEditorTab(false);
			this.stackContainer.selectChild(this.diagramPage);
			// reload diagram view
			this.refreshDiagram(reloaded);// showEditorTab reloaded the diagram content
		}
	},
	
	onSourcePageSaveCompleted: function(){
		this._onSaveCompleted(true);
	},
	
	onSourcePageClosed: function(){
		this.stackContainer.selectChild(this.diagramPage);
		if(this.openEditorFromView) {
			this.openEditorFromView = false;
			window.location.href = "#action=com.ibm.relm.explorer.web.showViewList"; //$NON-NLS-1$
			return;
		}
		// reload configurations
		if(this.sourcePage && this.sourcePage.configUpdated){
			this.refreshDiagram();
			this.sourcePage.configUpdated = false;
		}
	},
	
	onFormPageSaveCompleted: function(){
		this._onSaveCompleted(true);
	},
	
	onFormPageClosed: function(){
		this.stackContainer.selectChild(this.diagramPage);
		if(this.openEditorFromView) {
			this.openEditorFromView = false;
			if(this.formPage.returnToShared) {
				window.location.href = "#action=com.ibm.relm.explorer.web.showViewList&scope=shared"; //$NON-NLS-1$
			} else {
				window.location.href = "#action=com.ibm.relm.explorer.web.showViewList&scope=personal"; //$NON-NLS-1$
			}
			return;
		}
		// reload configurations
		if(this.formPage.configUpdated){
			this.refreshDiagram();
			this.formPage.configUpdated = false;
		} else {
			// in case IE8, do refreshDiagram
			if(dojo.isIE < 9 ) {
				this.refreshDiagram();
			}
		}
	},
	
	onSwitchToSource: function(){
		if(this.sourcePage){
			if(this._isDirty()){
				if (!confirm(this._messages.navigateAway + "\n\n" + this._messages.unsavedChanges + "\n\n" + this._messages.okOrCancel)) { //$NON-NLS-1$ //$NON-NLS-2$
					if(this.formPage && this.selectedTab == this.formPage) 
						this.switchToForm();
					else
						this.stackContainer.selectChild(this.diagramPage);
					return;
				}
			}
			this.sourcePage.setDiagramTitle(this.title);
			if(!this.sourcePage.isDirty()){
				this.sourcePage.load(this.viewUri);
			}
		}
	},
	
	switchToForm: function(params){
		if(this.formPage){
			this.stackContainer.selectChild(this.formPage);
			this.formPage.setSelectedTab(params);
		}
	},
	
	onSwitchToForm: function(){
		this._onFormEdit();
	},
	
	onSwitchToDesign: function(){
		if(this.formPage && this.formPage.isDirty()){
			if(this._editMode){
				this.refreshDiagramLocal();
			}else{
				this.refreshDiagram();
			}
		}
	},
	
	resize: function(size){
		// temporary fix.
		var bounds = dojo.position(this.domNode);
		if(size){
			bounds.h = size.h;
			this.top.resize(bounds);
		}
		bounds.h -= this._editMode ? ((this.formPage || this.sourcePage) ? 120 : 90) : 60;
		this.layout.resize(bounds);
	},
	
	showEditorTab: function(show){
		show = show && this._canEdit() ? true : false; // always boolean 
		if(show === this._editMode) 
			return false;
		this._editMode = show;
		// refresh editor 
		this.layout.setEditMode(show);
		this.showSidebar(show);
		
		this.printButton.domNode.style.display = !show && util.checkURLOption("printButton") ? "" : "none"; //$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$  
		this.reportButton.domNode.style.display = show ? "none" : "";//$NON-NLS-1$//$NON-NLS-2$
		this.editButton.domNode.style.display = show || !this._canEdit() ? "none" : "";//$NON-NLS-1$//$NON-NLS-2$
		this.saveButton.style.display = show ? "" : "none";//$NON-NLS-1$//$NON-NLS-2$
		this.saveAndCloseButton.style.display = show ? "" : "none";//$NON-NLS-1$//$NON-NLS-2$
		this.cancelButton.style.display = show ? "" : "none";//$NON-NLS-1$//$NON-NLS-2$
		this.stackContainer.tablist.domNode.style.display = show && (this.formPage || this.sourcePage) ? "" : "none";//$NON-NLS-1$//$NON-NLS-2$
		this.stackContainer.layout();
		var editor = this._getDiagramEditor();
		if(editor){
			var commandProcessor = editor.getCommandStack();
			this.connect(commandProcessor, "execute_it", this.updateDirty); //$NON-NLS-1$
		}
		this.resize();
		return true;
	},
	
	showSidebar: function(show){
		if(show){
			this._createSidebarContent();
			this.sidebarContainer.addSidebar(this._sideBar);
			if(dojo.isIE < 9){
				dojo.addClass(this._sideBar.domNode.parentNode, "no-transition"); //$NON-NLS-1$
			}
			this._createContextSensitiveHelp();
			if(window.onresize){
				setTimeout(function(){
					window.onresize({});
				}, 10);
			}
		}else if(this._sideBar){
			this.sidebarContainer.removeSidebar(this._sideBar);
			this._cleanSidebar();
		}
		if(window.onresize){
			this.sidebarContainer.display(show);
		}
	},
	
	_cleanSidebar: function(){
		if(this._setContentHandler) {
			this.disconnect(this._setContentHandler);
			this.setContentHandler = null;
		}
		if(this._sideBar){
			this._sideBar.destroyRecursive();
			this._sideBar = null;
			// this._sideBar.destroyRecursive might not destroy contents
			if (this._pagePropertiesPane) {
				this._pagePropertiesPane.destroyRecursive();
				this._pagePropertiesPane = null;
			}
			if (this._propertiesPane) {
				this._propertiesPane.destroyRecursive();
				this._propertiesPane = null;
			}
			if(this._pagePropertiesContent && this._pagePropertiesContent.domNode){
				this._pagePropertiesContent.destroyRecursive();
				this._pagePropertiesContent = null;
			}
			if(this._propertiesContent && this._propertiesContent.domNode){
				this._propertiesContent.destroyRecursive();
				this._propertiesContent = null;
			}
			if(this._palette && this._palette.domNode){
				this._palette.destroyRecursive();
				this._palette = null;
			}
		}
	},
	
	_canEdit: function(){
		if(this.permissions.modifyPermission) 
			return true;
		var config = this._getConfig();
		if(config && config.ownedBy === com.ibm.team.repository.web.client.session.getAuthenticatedContributorUri())
			return true;
		return false;
	},
	
	getEditorInput: function() {
		return this._editorInput;
	}
	
});

})();