/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.nodes._ClickableMixin"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes._ActionsMixin"); //$NON-NLS-1$


dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.nodes._ClickableMixin", //$NON-NLS-1$
	com.ibm.relm.explorer.web.ui.internal.view.nodes._ActionsMixin,
{
	href: "", //$NON-NLS-1$
	action: "", //$NON-NLS-1$
	
	addEventHandlerToShape: function(shape){
		this.connect(shape.getEventSource(), "onclick", "onClick"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	onClick: function(ev){
		if(this._getEditMode && this._getEditMode()) return;
		
		if(this.action){
			if(! this._doAction(this.action)){
				console.error("Unsupported method " + this.action + " is specified."); //$NON-NLS-1$ //$NON-NLS-2$
			}
		}else if(this.href){
			if(this.href.indexOf(":") < 0){//$NON-NLS-1$ 
				// relative path (e.g. "ibm.com")
				// then browser opens unexpected page.
				window.location = "http://" + this.href;//$NON-NLS-1$ 
			}else if(com.ibm.relm.explorer.web.ui.internal.util.isValidUrl(this.href)){
				window.location = this.href;
			}
		}
	},

// ======================= Setters/Getters =================================

	setHref: function(uri){
		this.href = uri;
	},
	
	setAction: function(action){
		this.action = action;
	}
});
