	/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.ple.web.ui.pages.ProductsPage"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.ple.web.ui.pages", "ProductsPageMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.ple.web.ui", "TreeMenuFactoryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dijit.form.Button"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.ActionRegistry"); //$NON-NLS-1$
dojo.require("com.ibm.relm.ple.web.ui.picker.LqeArtifactPicker"); //$NON-NLS-1$
dojo.require("com.ibm.relm.ple.web.ui.internal.views.ProductView"); //$NON-NLS-1$
dojo.require("com.ibm.relm.ple.web.ui.internal.views.ArtifactView"); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.CreateSnapshotDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.CreateBranchDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.UseBranchDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.UseSnapshotDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.FreezeBranch'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.RemoveDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.ProductSidebar'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.picker.AddUrlDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.picker.ProductPicker'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.EasyMessageBox'); //$NON-NLS-1$
dojo.require('jazz.ui.MessageBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.ProductBreadcrumbs'); //$NON-NLS-1$
dojo.require('jazz.ui.Toolbar'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.Button'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.MenuButton'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.Separator'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeSelection'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeMenuFactory'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Drawer'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.AutoHeightBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.MoveReusePlaceState'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Goto'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.internal.views.MultiSelectView'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.StatusMessage'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.tree.TreeRefresh'); //$NON-NLS-1$
dojo.require('relm.app.Permissions'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.StreamManagement'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.ProductSearchProvider'); //$NON-NLS-1$
dojo.require('jazz.util.html'); //$NON-NLS-1$
dojo.require("com.ibm.relm.ple.web.productedit.EditPropertiesDialog"); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.advanced.AdvancedSettings'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.ReplaceBaselineDialog'); //$NON-NLS-1$

(function(){

var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var productapi = com.ibm.relm.ple.web.ui.productapi;
var TreeSelection = com.ibm.relm.ple.web.ui.TreeSelection;
var MoveReusePlaceState = com.ibm.relm.ple.web.ui.MoveReusePlaceState;
var Goto = com.ibm.relm.ple.web.ui.Goto;
var FreezeBranch = com.ibm.relm.ple.web.ui.branch.FreezeBranch;
var Permissions = relm.app.Permissions;
var StreamManagement = com.ibm.relm.ple.web.rtc.StreamManagement;
var AdvancedSettings = com.ibm.relm.ple.web.advanced.AdvancedSettings;

// Start out as a flag saying this hasn't bee loaded yet.
var AnalysisUtil = false;

jazz.core.loader.load_async('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil', function() { //$NON-NLS-1$
	// Replace the flag with the actual object once loaded.
	AnalysisUtil = dojo.getObject('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil'); //$NON-NLS-1$
});

var messages = dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui.pages', 'ProductsPageMessages'); //$NON-NLS-1$ //$NON-NLS-2$

// All the toolbar button tooltips are the same as on the context menu, so just mixin those messages
dojo.mixin(messages, dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui', 'TreeMenuFactoryMessages')); //$NON-NLS-1$ //$NON-NLS-2$

function buildNoSelectionNode(showLoadingMessage) {
	var node = dojo.create('div', { //$NON-NLS-1$
		className: 'ple-ProductsPage-noSelection' //$NON-NLS-1$
	});


	node.innerHTML = showLoadingMessage ?
		messages.loading: messages.emptySidePane;
	return node;
}

dojo.declare(
	'com.ibm.relm.ple.web.ui.pages.ProductsPage', //$NON-NLS-1$
	[ dijit._Widget, dijit._Templated ],
	{
		messages: messages,
		templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','ui/pages/templates/ProductsPage.html'), //$NON-NLS-1$ //$NON-NLS-2$
		widgetsInTemplate: true,

		constructor: function()
		{	
			this._rootUri = null;
			this._filterSelectId = dijit.getUniqueId('ple-ProductsPage-filter'); //$NON-NLS-1$

			// This is a String from localStorage, but we want a boolean
			this._drawerInitiallyCollapsed = window.localStorage['com.ibm.relm.ple.detailsView.collapsed']; //$NON-NLS-1$
			this._drawerInitiallyCollapsed = this._drawerInitiallyCollapsed === 'true'; //$NON-NLS-1$
		},

		_onTreeFilterChange: function(e) {
			var filterOption = this._filterSelect.options[this._filterSelect.selectedIndex];
			var newTreeFilter = filterOption.value;

			window.location.href = '#' + dojo.objectToQuery({ //$NON-NLS-1$
				action: 'ple.browse_products', //$NON-NLS-1$
				show: newTreeFilter
			});
		},

		/**
		 * Adds a button to log the selected tree item in debug=true mode.
		 */
		_addDumpButton: function() {
			var query = window.location.search.substring(1, window.location.length);
			query = dojo.queryToObject(query);
			var debug = query.debug && query.debug.toLowerCase() === 'true'; //$NON-NLS-1$

			if (debug) {
				this._toolbar.addChild(new jazz.ui.toolbar.Separator());

				this._toolbar.addChild(
					new jazz.ui.toolbar.Button({
						title: 'Dump selected item to console.debug', //$NON-NLS-1$
						label: 'Dump', //$NON-NLS-1$
						imgSrc: 'com.ibm.relm.ple.web/ui/images/log-selected-item.gif', //$NON-NLS-1$
						onClick: dojo.hitch(this, this.logSelectedItem)
				}));

			}
		},

		_hideExportButton: function() {
			var exportEnabled = !!AdvancedSettings.product_export;

			if (!exportEnabled){
				dojo.style(this._exportButton.domNode, { display: 'none' } ); //$NON-NLS-1$
			}
		},

		/**
		 * Shows an "empty" details pane. Possiblly with help text for when no product //$NON-NLS-1$
		 * is selected.
		 *
		 * @param  {object} args args.showLoadingMessage will replace the normal help text with a loading message
		 *                       for slow to load products. args.clearTreeSelection will deselect the item in the tree visually, which may
		 *                       be needed after loading a bookmark to a dead product.
		 */
		clearDetailsPane: function(args) {
			args = args || {};
			this._detailsView && this._detailsView.destroyRecursive();
			this._detailsView = null;
			this._drawer.setDrawerContent(buildNoSelectionNode(args.showLoadingMessage));
			if (args.clearTreeSelection) {
				this._sidebar.deselectTrees();
			}
		},

		postCreate: function() {
			this._autoScrollHeight = new com.ibm.relm.common.web.ui.AutoHeightBox(this._drawer.domNode, {
				listenOnPage: 'com.ibm.relm.ple.web.ui.pages.ProductsPage' //$NON-NLS-1$
			});

			this._drawer.watch('collapsed', function(property, oldValue, newValue) { //$NON-NLS-1$
				window.localStorage['com.ibm.relm.ple.detailsView.collapsed'] = String(newValue); //$NON-NLS-1$
			});

			this._addDumpButton();
			this._hideExportButton();

			this.clearDetailsPane();

			dojo.addClass(this.domNode, 'ple-sidebar-page'); //$NON-NLS-1$

			this.subscribe('ple.product_redacted', this.refresh); //$NON-NLS-1$
			this.subscribe('ple.pick_product', this.showProductPicker); //$NON-NLS-1$
			this.subscribe('ple.pick_artifact', this.showArtifactPicker); //$NON-NLS-1$
			this.subscribe('ple.pick_hyperlink', this.showAddUrlDialog); //$NON-NLS-1$
			this.subscribe('ple.add_hyperlink', this.doAddUrl); //$NON-NLS-1$
			this.subscribe('ple.compare', this.compare); //$NON-NLS-1$
			this.subscribe('ple.history', this.showHistory); //$NON-NLS-1$
			this.subscribe('ple.remove_anything', this._removeAnything); //$NON-NLS-1$
			this.subscribe('ple.find_parents', this.gotoFindUse); //$NON-NLS-1$
			this.subscribe('ple.find_artifact_parents', this.gotoFindArtifactUse); //$NON-NLS-1$
			this.subscribe('ple.create_branch', this.showCreateBranchDialog); //$NON-NLS-1$
			this.subscribe('ple.create_snapshot', this.createSnapshot); //$NON-NLS-1$
			this.subscribe('ple.check_out', this.checkOut); //$NON-NLS-1$
			this.subscribe('ple.edit_properties', this.showSelectedEditProperties); //$NON-NLS-1$
			this.subscribe('ple.redact', this.redactProducts); //$NON-NLS-1$
			this.subscribe('ple.refresh', this.refreshTree); //$NON-NLS-1$

			this.subscribe('ple.branch_was_updated', this.refreshTree); //$NON-NLS-1$

			this.subscribe('ple.refresh_and_goto_path', this._refreshTreeAndGotoPath); //$NON-NLS-1$

			this.subscribe('ple.use_branch', this.showUseBranchDialog); //$NON-NLS-1$
			this.subscribe('ple.use_snapshot', this.showUseSnapshotDialog); //$NON-NLS-1$
			this.subscribe('ple.select_nothing', this.selectNothing); //$NON-NLS-1$
			this.subscribe('ple.debug_selected_item', this.logSelectedItem); //$NON-NLS-1$

			this.subscribe('ple.load_product_details', this.loadProductDetails); //$NON-NLS-1$
			this.subscribe('ple.load_link_details', this.loadLinkDetails); //$NON-NLS-1$
			this.subscribe('ple.multi_select_details', this.loadMultiSelectDetails); //$NON-NLS-1$
			this.subscribe('ple.clear_details', this.clearDetailsPane); //$NON-NLS-1$

			this.subscribe('ple.show_drag_message', this.showDragMessage); //$NON-NLS-1$
			this.subscribe('ple.hide_drag_message', this.hideDragMessage); //$NON-NLS-1$

			this.connect(TreeSelection, 'onSelectionChange', this._enableToolbarButtons); //$NON-NLS-1$
			this.connect(MoveReusePlaceState, 'onChosenChange', this._enableToolbarButtons); //$NON-NLS-1$

			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("ple.browse_products", this, 'browseProductsAction'); //$NON-NLS-1$ //$NON-NLS-2$

			ActionRegistry.registerAction('ple.view_path', this, 'selectProductTreePathAction'); //$NON-NLS-1$ //$NON-NLS-2$

			delete this._filterSelectId;

			if (StreamManagement.enabled) {
				this._addRtcStreamManagementMenu();
			}

			// Load the product grouping list now or whenever notified.
			this.loadProductGroupings();
			this.subscribe('ple.product_groupings_did_change', this.loadProductGroupings); //$NON-NLS-1$

			//Load recently imported groupings
			this.loadRecentImports();
			this.subscribe('ple.recent_imports_did_change', this.loadRecentImports); //$NON-NLS-1$

			this.enableRedaction();
		},

		onShow: function() {
			PlatformUI.getWorkbench().setTitle(this.messages.browseProducts);
		},
		
		/**
		 * Hide redaction toolbar item if not jazz admin
		 */
		enableRedaction: function() {
			if (!Permissions.canProductsRedact()) {
				dojo.addClass(this._redactButton.domNode, 'j-hide'); //$NON-NLS-1$
			}			
		},

		_redactSelected: function() {
			var allSelected = TreeSelection.getAllSelectedSites();
			var allSelectedProducts = dojo.map(allSelected, function(selection) { 
				return selection.product; 
			});
			this.redactProducts(allSelectedProducts);
		},

		importProducts: function(args) {
			var site = TreeSelection.getSelectedSite();
			productapi.importProducts(site);
		},

		_exportSelected: function() {
			var product = TreeSelection.getSelectedSite().product;
			productapi.exportProduct(product);
		},

		redactProducts: function(products) {
			productapi.redactProducts(products, this.refresh);
		},

		refresh: function(){
			com.ibm.relm.ple.web.ui.tree.TreeRefresh.refresh().then(function() {
			 	dojo.publish('ple.detail_view.refresh'); //$NON-NLS-1$
			});
		},

		showSelectedEditProperties: function() {
			var selectedSite = TreeSelection.getSelectedSite();
			var product = selectedSite.product;
			var parentProduct = selectedSite.parentProduct;

			// lazy load the product if needed.
			TreeSelection.store.loadItem({
				item: product,
				onItem: function(fullItem) {
					var dialog = new com.ibm.relm.ple.web.productedit.EditPropertiesDialog({
						itemVersion: fullItem,
						parentItemVersion: parentProduct,
						site: selectedSite
					});

					dialog.startup();
				}
			});
		},

		loadRecentImports: function() {
			var self = this;
			jazz.client.xhrGet({
				url: net.jazz.ajax._contextRoot + "/ple/recent_imports", //$NON-NLS-1$
				handleAs: "json", //$NON-NLS-1$
				load: function(recentImports) {
					dojo.empty(self.treeImports);
					if (recentImports.length) {
						self.treeImports.style.display = ""; //$NON-NLS-1$
						dojo.forEach(recentImports, function(recentImport) {
							var formattedDate = dojo.date.locale.format(
								new Date(recentImport.creationTime),
								{ formatLength: 'medium' } //$NON-NLS-1$
							);
							var displayName = dojo.replace(self.messages.recentImportX, [recentImport.fileName, formattedDate]);
							dojo.create("option", { //$NON-NLS-1$
								innerHTML: jazz.util.html.escape(displayName),
								value: recentImport.collectionName
							}, self.treeImports, "last"); //$NON-NLS-1$
						}, self);
					} else {
						self.treeImports.style.display = "none"; //$NON-NLS-1$
					}
				}
			});
		},

		loadProductGroupings: function() {
			var self = this;
			this.loadingProductGrouping = jazz.client.xhrGet({
					url: net.jazz.ajax._contextRoot + "/ple/product_grouping", //$NON-NLS-1$
					handleAs: "json", //$NON-NLS-1$
					content: {
						method: "loadGroupings" //$NON-NLS-1$
					},
					load: function(groupings) {
						//Delete old product groupings on this list
						dojo.empty(self.treeGroupings);

						//Add new product groupings
						if (groupings && groupings.length > 0) {
							self.treeGroupings.style.display = ""; //$NON-NLS-1$
							dojo.forEach(groupings, function(grouping){
								dojo.create("option", { //$NON-NLS-1$
									innerHTML: jazz.util.html.escape(grouping.name),
									value: grouping.uri
								}, self.treeGroupings, "last"); //$NON-NLS-1$
							}, self);
						}

						// If loading a project grouping for the URI, we might
						// have loaded that grouping before we even know it's
						// name. Now that we know all the names, check the
						// current ?show value and set it again so that the
						// dropdown scope menu will reflect the current
						// project grouping. This feels a little brittle.
						var hash = dojo.doc.location.hash;
						var hashObject = dojo.queryToObject(hash.substring(1));
						self._selectFilterValue(hashObject.show);
					},
					error: function(error, args) {
						dojo.publish("ple.product_tree_xhrError", [args.xhr, true]); //$NON-NLS-1$
					},
					handle: function() {
						delete self.loadingProductGrouping;
					}
			});
		},

		_addRtcStreamManagementMenu: function() {
			// Expect that this is before Delete, but after everything else.
			var atIndex = 4;

			this._rtcButton = jazz.ui.toolbar.MenuButton({
				group: 'ple.products_page.toolbar', //$NON-NLS-1$
				destroyOnClose: true,
				imgClass: 'ple-icon-rtc', //$NON-NLS-1$
				title: this.messages.streamManagement 
			});

			this._rtcButton.set('menuProvider', function() { //$NON-NLS-1$
				return StreamManagement.createMenuForSelectedSites();
			});

			this._toolbar.addChild(new jazz.ui.toolbar.Separator(), atIndex++);
			this._toolbar.addChild(this._rtcButton, atIndex++);
		},

		showDragMessage: function(htmlMessage) {
			if (!this._dragMessageBox) {
				this._dragMessageBox = new jazz.ui.MessageBox();
				this._dragMessageBox.placeAt(this._drawer.domNode);
			}

			this._dragMessageBox.showMessage({
				type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
				summary: htmlMessage,
				closable: false
			});

			dojo.style(this._dragMessageBox.domNode, {
				position: 'absolute', //$NON-NLS-1$
				bottom: '10px', //$NON-NLS-1$
				width: '500px', //$NON-NLS-1$
				left: '50%', //$NON-NLS-1$
				marginLeft: '-250px', //$NON-NLS-1$
				zIndex: '100' //$NON-NLS-1$
			});
		},

		hideDragMessage: function() {
			if (!this._dragMessageBox) return;
			this._dragMessageBox.destroyRecursive();
			delete this._dragMessageBox;
		},

		/**
		 * Enables and disables toolbar buttons based on the currently selected item.
		 */
		_enableToolbarButtons: function() {
			this._createProductButton.set('enabled', false); //$NON-NLS-1$
			this._createSnapshotButton.set('enabled', false); //$NON-NLS-1$
			this._createBranchButton.set('enabled', false); //$NON-NLS-1$
			this._rtcButton && this._rtcButton.set('enabled', false); //$NON-NLS-1$
			this._addProductButton.set('enabled', false); //$NON-NLS-1$
			this._addArtifactButton.set('enabled', false); //$NON-NLS-1$
			this._addLinkButton.set('enabled', false); //$NON-NLS-1$
			this._findUseButton.set('enabled', false); //$NON-NLS-1$
			this._startAnalysisButton.set('enabled', false); //$NON-NLS-1$
			this._replaceBranchButton.set('enabled', false); //$NON-NLS-1$
			this._replaceSnapshotButton.set('enabled', false); //$NON-NLS-1$
			this._freezeBranchButton.set('enabled', false);  //$NON-NLS-1$
			this._showAuditHistoryButton.set('enabled', false); //$NON-NLS-1$
			this._compareButton.set('enabled', false); //$NON-NLS-1$
			this._moveButton.set('enabled', false); //$NON-NLS-1$
			this._reuseButton.set('enabled', false); //$NON-NLS-1$
			this._placeButton.set('enabled', false); //$NON-NLS-1$
			this._removeButton.set('enabled', false); //$NON-NLS-1$
			this._redactButton.set('enabled', false); //$NON-NLS-1$
			this._exportButton.set('enabled', false); //$NON-NLS-1$
			this._importButton.set('enabled', false); //$NON-NLS-1$

			var allSelected = TreeSelection.getAllSelectedSites();
			var multiSelected = allSelected.length > 1;

			var canModify = Permissions.canProductsModify();
			var canBranch = Permissions.canProductsBranch();
			var canSnapshot = Permissions.canProductsCreateSnapshot();
			var canAddProperty = Permissions.canProductsAddProperty();
			var canDeleteProperty = Permissions.canProductsDeleteProperty();
			var canRedact = Permissions.canProductsRedact();

			switch (allSelected.length) {
			case 0:
				this._createProductButton.set('title', messages.createProduct);  //$NON-NLS-1$
				this._createProductButton.set('enabled', canModify); //$NON-NLS-1$
				return;

			case 1:
				this._compareButton.set('title', messages.compareWithLastSnapshot); //$NON-NLS-1$
				this._compareButton.set('imgClass', 'ple-icon-compareLastSnapshot'); //$NON-NLS-1$ //$NON-NLS-2$
				break;

			default:
				this._compareButton.set('title', messages.compareSelected); //$NON-NLS-1$
				this._compareButton.set('imgClass', 'ple-icon-compareSnapshots'); //$NON-NLS-1$ //$NON-NLS-2$
				break;
			}

			var firstSelected = allSelected[0];
			var firstParent = firstSelected.link ? firstSelected.product : firstSelected.parentProduct;
			var allHaveSameParent = dojo.every(allSelected, function(sel) {
				var parent = sel.link ? sel.product : sel.parentProduct;
				return parent == firstParent;
			});

			var type = TreeSelection.getSelectedType();

			var isChild = !!TreeSelection.getSelectedSite().parentProduct;

			// Reuse anything!
			this._reuseButton.set('enabled',  canModify); //$NON-NLS-1$

			switch (type) {
			case 'product': //$NON-NLS-1$
				var itemVersion = TreeSelection.getSelectedSite().product;
				var immutable = itemVersion['pd:immutable']; //$NON-NLS-1$
				var pinnedTip = itemVersion['pd:pinned'] && itemVersion['ple:isTipVersion']; //$NON-NLS-1$ //$NON-NLS-2$
				var frozenTip = itemVersion["ple:isFrozenTip"]; //$NON-NLS-1$
				var frozenHierarchy = itemVersion["ple:isFrozenHierarchy"]; //$NON-NLS-1$
				var unableToCheckout = frozenTip || frozenHierarchy || pinnedTip;
				var isConfiguration = itemVersion.conditionVariables !== undefined;
				var areAllSelectedProducts = TreeSelection.areAllSelectedProducts();
				var streamOrComponent = itemVersion.rtcStream || itemVersion.rtcComponent; 

				this._compareButton.set('enabled', areAllSelectedProducts && allSelected.length <= 2); //$NON-NLS-1$
				this._startAnalysisButton.set('enabled', !multiSelected); //$NON-NLS-1$
				this._showAuditHistoryButton.set('enabled', !multiSelected); //$NON-NLS-1$
				this._findUseButton.set('enabled', !multiSelected); //$NON-NLS-1$
				this._findUseButton.set('title', this.messages.findUse); //$NON-NLS-1$
				this._moveButton.set('enabled', allHaveSameParent && isChild && canModify && !frozenHierarchy); //$NON-NLS-1$
				this._createBranchButton.set('enabled', !multiSelected && canBranch && !frozenHierarchy); //$NON-NLS-1$
				this._replaceBranchButton.set('enabled', isChild && !multiSelected && canModify && !frozenHierarchy); //$NON-NLS-1$
				this._exportButton.set('enabled', canModify && !multiSelected); //$NON-NLS-1$
				this._redactButton.set('enabled', areAllSelectedProducts && canRedact); //$NON-NLS-1$
				this._rtcButton && this._rtcButton.set('enabled', !multiSelected && !isConfiguration); //$NON-NLS-1$

				//If in frozen hierarchy, only enable read only actions + unfreeze on frozen product
				if (unableToCheckout) {
					if (frozenTip && immutable && !multiSelected && canSnapshot && canModify) {
						this._freezeBranchButton.set('enabled', !streamOrComponent); //$NON-NLS-1$
						this._freezeBranchButton.set('title', messages.unfreezeBranch); //$NON-NLS-1$
						this._freezeBranchButton.set('imgClass', 'ple-icon-unfreezeBranch'); //$NON-NLS-1$ //$NON-NLS-2$
					}
					return;
				}

				//The actions below this modify products/tree so they are disabled in a frozen hierarchy or pinned tip
				this._createProductButton.set('enabled', !multiSelected && canModify && !isConfiguration); //$NON-NLS-1$
				this._createProductButton.set('title', messages.createProduct); //$NON-NLS-1$
				if (immutable) {
					//Check out
					this._createSnapshotButton.set('enabled', !multiSelected && canModify); //$NON-NLS-1$
					this._createSnapshotButton.set('title', messages.checkOut); //$NON-NLS-1$
					this._createSnapshotButton.set('imgClass', 'ple-icon-checkOut'); //$NON-NLS-1$ //$NON-NLS-2$
					this._createSnapshotButton.set('onClick', dojo.hitch(this, this.checkOutSelected)); //$NON-NLS-1$
				} else {
					//Create snapshot
					this._createSnapshotButton.set('enabled', !multiSelected && canSnapshot); //$NON-NLS-1$
					this._createSnapshotButton.set('title', messages.createSnapshot); //$NON-NLS-1$
					this._createSnapshotButton.set('imgClass', 'ple-icon-createSnapshot'); //$NON-NLS-1$ //$NON-NLS-2$
					this._createSnapshotButton.set('onClick', dojo.hitch(this, this.createSelectedSnapshot)); //$NON-NLS-1$
				}
				
				this._addProductButton.set('enabled', !multiSelected && canModify && !isConfiguration); //$NON-NLS-1$
				this._addProductButton.set('title', messages.addProduct); //$NON-NLS-1$
				this._importButton.set('enabled', !multiSelected && canModify); //$NON-NLS-1$
				this._importButton.set('title', (allSelected.length) ? messages.importChildProducts : messages.importProducts); //$NON-NLS-1$
				this._addArtifactButton.set('enabled', !multiSelected && canAddProperty && !isConfiguration); //$NON-NLS-1$
				this._addLinkButton.set('enabled', !multiSelected && canAddProperty && !isConfiguration); //$NON-NLS-1$
				this._replaceSnapshotButton.set('enabled', isChild && !multiSelected && canModify); //$NON-NLS-1$
				this._replaceSnapshotButton.set('title', this.messages.replaceSnapshot); //$NON-NLS-1$
				this._replaceSnapshotButton.set('imgClass', 'ple-icon-replaceSnapshot'); //$NON-NLS-1$ //$NON-NLS-2$
				MoveReusePlaceState.isPlaceReady() && this._placeButton.set('enabled', !multiSelected && canModify); //$NON-NLS-1$
				if (immutable && !multiSelected && canSnapshot) {
					if (frozenTip) {
						this._freezeBranchButton.set('enabled', canModify && !streamOrComponent); //$NON-NLS-1$
						this._freezeBranchButton.set('title', messages.unfreezeBranch); //$NON-NLS-1$
						this._freezeBranchButton.set('imgClass', 'ple-icon-unfreezeBranch'); //$NON-NLS-1$ //$NON-NLS-2$
					} else {
						this._freezeBranchButton.set('enabled', canSnapshot && !streamOrComponent); //$NON-NLS-1$
						this._freezeBranchButton.set('title', messages.freezeBranch); //$NON-NLS-1$
						this._freezeBranchButton.set('imgClass', 'ple-icon-freezeBranch'); //$NON-NLS-1$ //$NON-NLS-2$
					}
				}
				this._removeButton.set('enabled', allHaveSameParent && canModify); //$NON-NLS-1$

				return;

			case 'link': //$NON-NLS-1$
				var artifact = TreeSelection.getSelectedSite().link;
				frozenHierarchy = FreezeBranch.checkSelectedFrozenHierarchy();

				this._moveButton.set('enabled', allHaveSameParent && canModify && !frozenHierarchy); //$NON-NLS-1$
				this._removeButton.set('enabled', allHaveSameParent && canDeleteProperty && !frozenHierarchy); //$NON-NLS-1$

				this._startAnalysisButton.set('enabled', !multiSelected); //$NON-NLS-1$
				if (!multiSelected && artifact.isDoorsBaseline) {
					this._replaceSnapshotButton.set('enabled', true); //$NON-NLS-1$
					this._replaceSnapshotButton.set('title', this.messages.replaceBaseline); //$NON-NLS-1$
					this._replaceSnapshotButton.set('imgClass', 'ple-icon-replaceBaseline'); //$NON-NLS-1$ //$NON-NLS-2$
				}
				this._placeButton.set('enabled', false); //$NON-NLS-1$
				this._findUseButton.set('enabled', true); //$NON-NLS-1$
				this._findUseButton.set('title', this.messages.findUseInProducts); //$NON-NLS-1$
				return;

			default:
				return;
			}
		},

		logSelectedItem: function() {
			var selected = TreeSelection.getSelectedSite();
			if (!selected) return;

			if (selected.link) {
				console.debug('Link ' + selected.link.name," - ", selected.link); //$NON-NLS-1$ //$NON-NLS-2$
			}
			else {
				console.warn('Remember, what\'s cached in the tree may be older than ProductStore'); //$NON-NLS-1$
				console.debug(selected.product.name," - ", selected.product); //$NON-NLS-1$
			}
		},

		gotoSelectedFindUse: function(e) {
			var sel = TreeSelection.getSelectedSite();
			if (sel.link) {
				var artifactUri = sel.link.uri;
				var privateBaseline = sel.link.privateBaseline;
				Goto.gotoFindArtifactUse(artifactUri, privateBaseline);
				return;
			}
			else {
				var itemVersionUri = sel.product.uri;
				Goto.gotoFindUse(itemVersionUri);
				return;
			}
		},

		gotoFindArtifactUse: function(artifactUri, privateBaseline) {
			Goto.gotoFindArtifactUse(artifactUri, privateBaseline);
		},

		gotoFindUse: function(itemVersionUri) {
			if (!itemVersionUri) return;
			Goto.gotoFindUse(itemVersionUri);
		},

		launchAnalysis: function(args) {
			var selected = TreeSelection.getSelectedSite();
			if (selected.link) {
				AnalysisUtil.createAnalysisForResource(selected.link.oslcConceptUri	);
			}
			else {
				AnalysisUtil.createAnalysisForResource(selected.product.uri);
			}
		},

		_refreshTreeAndGotoPath: function(idPath) {
			this._sidebar.refresh().then(dojo.hitch(this, function() {
				Goto.gotoProductTreePath(idPath);
				var flashArgs = {
					// match the selected row color when flashing new node
					endColor: '#fff4e2' //$NON-NLS-1$
				};
				this._sidebar._productTree.flashNodeAtIdPath(idPath, flashArgs);
			}));
		},

		_createProduct: function() {
			productapi.createProduct(TreeSelection.getSelectedSite());
		},

		showSelectedCreateBranchDialog: function() {
			this.showCreateBranchDialog(TreeSelection.getSelectedSite());
		},

		showCreateBranchDialog: function(selected) {
			if (!selected) return;

			var parent = selected.parentProduct;
			var product = selected.product;

			var args = {
				idPath: selected.idPath,
				productName: product.name,
				productVersionUri: product.uri,
				viewMemberUri: product['pd:part'], //$NON-NLS-1$
				parentVersionUri: parent ? parent.uri : null,
				oldBranchDimensions: product._branch_dimensions
			};

			var d = new com.ibm.relm.ple.web.ui.branch.CreateBranchDialog(args);
			d.startup();
		},

		showSelectedUseBranchDialog: function(e) {
			var selected = TreeSelection.getSelectedSite();
			this.showUseBranchDialog(selected);
		},

		showUseBranchDialog: function(selected) {
			if (!selected || !selected.parentProduct) return;

			var args = {
					item: selected.product,
					parentItem: selected.parentProduct,
					idPath: selected.idPath
			};

			var d = new com.ibm.relm.ple.web.ui.branch.UseBranchDialog(args);
			d.startup();
		},

		freezeSelectedBranch: function(e) {
			var freezeClass = this._freezeBranchButton.get('imgClass'); //$NON-NLS-1$
			if (freezeClass == "ple-icon-freezeBranch") //$NON-NLS-1$
				FreezeBranch.freezeSelectedBranch();
			else
				FreezeBranch.unfreezeSelectedBranch();
		},

		moveSelected: function() {
			MoveReusePlaceState.saveSelectionForMove();
		},

		reuseSelected: function() {
			MoveReusePlaceState.saveSelectionForReuse();
		},

		placeSelected: function() {
			MoveReusePlaceState.placeSavedSelection();
		},

		showSelectedUseSnapshotDialog: function(e) {
			var selected = TreeSelection.getSelectedSite();
			if (selected.link && selected.link.isDoorsBaseline) {
				this.showReplaceBaselineDialog(selected);
			}
			else {
				this.showUseSnapshotDialog(selected.parentProduct, selected.product);
			}
		},

		showReplaceBaselineDialog: function(site) {
			var d = new com.ibm.relm.ple.web.ui.pages.ReplaceBaselineDialog({
				site: site
			});
			d.startup();
		},

		showUseSnapshotDialog: function(parentItem, item) {
			if (!item || !parentItem) return;

			var args = {
				parentItemVersion: parentItem,
				itemVersion: item
			};

			var d = new com.ibm.relm.ple.web.ui.pages.UseSnapshotDialog(args);
			d.startup();
		},

		createSelectedSnapshot: function() {
			var selected = TreeSelection.getSelectedSite();
			var itemVersion = selected.product;
			var canFreeze = !itemVersion.rtcStream && !itemVersion.rtcComponent;
			var itemVersionUri = TreeSelection.store.getValue(itemVersion, 'uri'); //$NON-NLS-1$
			var itemVersionName = TreeSelection.store.getValue(itemVersion, 'name'); //$NON-NLS-1$
			var branchName = TreeSelection.store.getValue(itemVersion, '_branch_name');  //$NON-NLS-1$
			var branchUri = TreeSelection.store.getValue(itemVersion, 'pd:branch'); //$NON-NLS-1$
			this.createSnapshot(itemVersionUri, itemVersionName, branchName, branchUri, canFreeze);
		},

		createSnapshot: function(productId, productName, branchName, branchUri, canFreeze) {
			var d = new com.ibm.relm.ple.web.ui.pages.CreateSnapshotDialog({
				productName: productName,
				productId: productId,
				branchName: branchName,
				branchUri: branchUri,
				canFreeze: canFreeze
			});
			d.startup();
		},

		checkOutSelected: function(args) {
			var selected = TreeSelection.getSelectedSite();
			productapi.checkOutProduct(selected.product, selected.parentProduct);
		},

		compareSelected: function() {
			var allSelected = TreeSelection.getAllSelectedSites();

			if (allSelected.length === 1) {
				var selected = allSelected[0];
				var itemVersionUri = TreeSelection.store.getValue(selected.product, 'uri'); //$NON-NLS-1$
				this.compare(itemVersionUri, null);
			}
			else {
				var left = allSelected[1];
				var right = allSelected[0];
				var leftUri = TreeSelection.store.getValue(left.product, 'uri'); //$NON-NLS-1$
				var rightUri = TreeSelection.store.getValue(right.product, 'uri'); //$NON-NLS-1$
				this.compare(leftUri, rightUri);
			}
		},

		// XXX: These are revered order since RIGHT is always required. Maybe this should change.
		/**
		 * Run product comparison
		 * @param  {[string]} rightItemVersionUri require right side of compare.
		 * @param  {[type]} leftItemVersionUri  optional left side of compare. If null, the last snapshot of the right is
		 * compared against.
		 */
		compare: function(rightItemVersionUri, leftItemVersionUri) {
			// Yes, LEFT can be null, and RIGHT must be set.
			// This is because we may want to compare a product to its last snapshot.
			// In that case, the right of the results will be the selected object, the left
			// will be its predecessor.

			Goto.gotoCompare(leftItemVersionUri, rightItemVersionUri);
		},

		showSelectedHistory: function() {
			var itemVersionUri = TreeSelection.store.getValue(TreeSelection.getSelectedSite().product, 'uri'); //$NON-NLS-1$
			this.showHistory(itemVersionUri);
		},

		showHistory: function(itemVersionUri) {
			Goto.gotoShowHistory(itemVersionUri);
		},

		showSelectedArtifactPicker: function(e) {
			this.showArtifactPicker(TreeSelection.getSelectedSite());
		},

		/**
		 * Opens the LQE artifact picker dialog to add an artifact to the selected product.
		 *
		 * @param  {object} selected the selected product to add the artifact to as returned by TreeSelection.
		 */
		showArtifactPicker: function(selected) {
			if (!selected.product) return;
			var product = selected.product;

			var parentVersionUri = this._sidebar.store.getValue(product, 'uri'); //$NON-NLS-1$
			var parentPartUri = this._sidebar.store.getValue(product, 'pd:part'); //$NON-NLS-1$

			var picker = new com.ibm.relm.ple.web.ui.picker.LqeArtifactPicker({
				parentUri: parentVersionUri,
				parentPart: parentPartUri,
				parentIdPath: selected.idPath,
				filterProducts: true,
				showAddAndClose: true
			});

			picker.startup();
		},

		/**
		 * Shows the Add Product picker for the currently selected product, if
		 * any.
		 */
		showSelectedProductPicker: function() {
			var selected = TreeSelection.getSelectedSite();
			if (!selected) return;

			this.showProductPicker(selected);
		},

		/**
		 * Shows the Add Product picker.
		 * @param  {object} selected A 'selected' object from TreeSelection.
		 */
		showProductPicker: function(selected) {
			if (!selected) return;

			var picker = new com.ibm.relm.ple.web.ui.picker.ProductPicker({
				selected: selected
			});

			picker.startup();
		},

		showSelectedAddUrlDialog: function(e) {
			this.showAddUrlDialog(TreeSelection.getSelectedSite());
		},

		showAddUrlDialog: function(selected) {
			var parentItem = selected.product;
			var parentVersionUri = this._sidebar.store.getValue(parentItem, 'uri'); //$NON-NLS-1$
			var parentPartUri = this._sidebar.store.getValue(parentItem, 'pd:part'); //$NON-NLS-1$
			var parentIdPath = selected.idPath;

			var self = this;

			var picker = null;
			picker = new com.ibm.relm.ple.web.ui.picker.AddUrlDialog({
				dialogTitle: this.messages.addUrlDialogTitle,//TODO: Is this useless?

				onOk: function(url, label, comments) {
					var message = com.ibm.relm.common.web.StatusMessage.show(self.messages.addingLink);

					var callback = dojo.hitch(this, function(result) {
						var newLinkItem = result.link;
						var linkIdPath = parentIdPath.concat(newLinkItem.pathId);

						com.ibm.relm.ple.web.ui.tree.TreeRefresh.refresh({
							selectParentPath: linkIdPath,
							flashPath: true
						}).addBoth(function() {
							message.hide();
							picker.close();
						});

						dojo.publish('ple.detail_view.refresh', [result.itemVersion]); //$NON-NLS-1$
					});

					var errback = function(_, args){
						message.hide();
						picker.showXhrError(args.xhr);
					};

					self.doAddUrl(url, label, comments, parentVersionUri, parentPartUri, callback, errback);
				}
			});

			picker.startup();
		},

		//Separate method to do actual adding of url so it can be used in other places
		doAddUrl: function(url, label, comments, parentVersionUri, parentPartUri, callback, errback){
			jazz.client.xhrPost({
				url: net.jazz.ajax._contextRoot + '/ple/links', //$NON-NLS-1$
				content: {
					itemVersionUri: parentVersionUri,
					viewMemberUri: parentPartUri,
					uri: url,
					title: label,
					description: comments
				},
				handleAs: 'json', //$NON-NLS-1$
				load: callback,
				error: errback
			});
		},

		/**
		 * Gets the currently selected item in the tree, if any,
		 * and does the appropriate delete style action for the selected
		 * type, either a product or artifact link.
		 */
		_removeSelected: function() {
			var allSelected = TreeSelection.getAllSelectedSites();
			this._removeAnything(allSelected);
		},

		/**
		 * Shows dialog to remove any number of links and child products.
		 * All must have the same parent product.
		 * @param  {array} allSelected selected objects from TreeSelection.
		 */
		_removeAnything: function(allSelected) {
			// If these are not top-level products, they must all have the same parent product.
			var parentProduct = null;

			function saveParent(newParent) {
				if (!parentProduct) {
					parentProduct = newParent;
				}

				if (parentProduct !== newParent) {
					throw new Error('All seleted items must have same parent.'); //$NON-NLS-1$
				}
			}

			var immutable = false;
			var hasChildren = false;

			var partAndChildUris = [];
			var linkUris = [];

			for (var i = 0; i < allSelected.length; i++) {
				var selected = allSelected[i];

				if (selected.link) {
					linkUris.push(selected.link.uri);

					// Can't delete link targets, so it's like an immutable product is selected.
					immutable = true;

					saveParent(selected.product);
				}
				else {
					var product = selected.product;

					partAndChildUris.push({
						part: product['pd:part'], //$NON-NLS-1$
						child: product.uri
					});

					if (product['pd:immutable']) { //$NON-NLS-1$
						immutable = true;
					}

					var children = product.children;
					if (children === true || children && children.length) {
						hasChildren = true;
					}

					saveParent(selected.parentProduct);
				}
			}

			var args = {
				parentProductUri: parentProduct && parentProduct.uri,
				parentViewUri: parentProduct && parentProduct['pd:view'], //$NON-NLS-1$
				partAndChildUris: partAndChildUris,
				linkUris: linkUris,
				hasChildren: hasChildren,
				immutable: immutable
			};
			if (allSelected.length == 1)
				args["name"] = (allSelected[0].link)? allSelected[0].link.name : allSelected[0].product.name; //$NON-NLS-1$

			var removeDialog = new com.ibm.relm.ple.web.ui.pages.RemoveDialog(args);

			removeDialog.startup();
		},

		_selectFilterValue: function(newOptionValue) {
			for (var i = 0; i < this._filterSelect.options.length; i++) {
				var option = this._filterSelect.options[i];
				if (option.value == newOptionValue) {
					this._filterSelect.selectedIndex = i;
					break;
				}
			}
		},

		/**
		 * Jazz action to view a product tree path.
		 * @param  {object} jazzEvent event with .path property to view. Slash separated tree IDs.
		 */
		selectProductTreePathAction: function(jazzEvent) {
			var idPath = jazzEvent.path;
			if (!idPath) return;

			var treeFilter = jazzEvent.show;
			if (treeFilter) {
				this._setTreeFilter(treeFilter);
			}

			idPath = idPath.split('/'); //$NON-NLS-1$
			this._sidebar.selectProductTreePath(idPath);
		},

		_setTreeFilter: function(filter) {
			// Try to set this now. Will work for recents and favorites. If
			// this is a product grouping, then they might not have loaded
			// yet. This will get set again after they load so we know which
			// name in the menu to select (we might only know the URI right
			// now).
			this._selectFilterValue(filter);

			this._sidebar.set('treeFilter', filter); //$NON-NLS-1$
		},

		/**
		 * Updates the tree filter and tells the sidebar to update in response.
		 * @param  {[type]} actionEvent [description]
		 * @return {[type]}             [description]
		 */
		browseProductsAction: function(actionEvent){
			var treeFilter = actionEvent.show;
			if (!treeFilter) treeFilter = 'recents'; //$NON-NLS-1$

			this._setTreeFilter(treeFilter);
		},

		/**
		 * Refreshes the tree with the latest data from the sever. Causes icons
		 * to redraw if needed. Also enables and disabled toolbar buttons to match
		 * the current selected item, if any.
		 *
		 * Code that may want to change the selected tree node first may need
		 * to call tree.refreshStore and _enableToolbarButtons itself--this is a convenience.
		 */
		refreshTree: function() {
			dojo.publish('ple.product_tree_hide_message'); //$NON-NLS-1$
			return this._sidebar.refresh();
		},

		isDetailsViewDirty: function() {
			return this._detailsView && this._detailsView.isDirty && this._detailsView.isDirty();
		},

		/**
		 * Completely rebuilds the store, models, and visual tree. The tree widget is destroyed and rebuilt.
		 * Used for a last resort refresh that will always pull the latest information. Should not be needed often.
		 */
		_fullRefresh: function(force) {
			if (force || !this.isDetailsViewDirty()) {
				return this._sidebar._fullRefresh(true);
			}
			else {
				// FIXME: This doesn't return a Deferred? Is anything using this result anymore?
				var d = new com.ibm.relm.ple.web.ui.tree.DiscardChangesDialog({
					onDiscard: dojo.hitch(this, this._fullRefresh, true)
				});
				d. startup();
				return undefined;
			}
		},

		_onFullRefresh: function(e) {
			this._fullRefresh(false);
		},

		loadProductDetails: function(productUri, partUri, customViewWidget) {
			clearTimeout(this._clearViewTimeout);

			// Don't clear the detail pane right away to avoid flashing. Only after a delay of loading.
			this._clearViewTimeout = setTimeout(dojo.hitch(this, function() {
				this.clearDetailsPane({
					showLoadingMessage: true
				});
			}), 400);

			jazz.client.xhrGet({
				handleAs: 'json', //$NON-NLS-1$
				url: net.jazz.ajax._contextRoot + '/ple/product_version', //$NON-NLS-1$
				content: {
					itemVersionUri: productUri,
					viewMemberUri: partUri
				},

				handle: dojo.hitch(this, function() {
					clearTimeout(this._clearViewTimeout);
				}),

				load: dojo.hitch(this, function (product) {
					this._detailsView && this._detailsView.destroyRecursive();
					if (!product) return;

					var ViewWidget = customViewWidget ? customViewWidget : com.ibm.relm.ple.web.ui.internal.views.ProductView;

					this._detailsView = new ViewWidget({
						product: product
					});

					this._drawer.setDrawerContent(this._detailsView.domNode);
				}),

				error: dojo.hitch(this, function(error) {
					this._detailsView && this._detailsView.destroyRecursive();
					console.log(error);

					this.refreshTree();
					this.clearDetailsPane();
				})
			});
		},

		loadMultiSelectDetails: function() {
			if (this._detailsView) {
				if (this._detailsView.isMultiselect) {
					return;
				}

				this._detailsView.destroyRecursive();
			}

			this._detailsView = new com.ibm.relm.ple.web.ui.internal.views.MultiSelectView({});
			this._drawer.setDrawerContent(this._detailsView.domNode);
		},


		/**
		 * @param  {object} itemVersion item version linked from.
		 * @param  {object} link        item for the link.
		 */
		loadLinkDetails: function(itemVersion, link) {

			if (link.isDoorsBaseline) {
				var artifactUri = link.privateBaseline;
				var artifactOslcUri = null;
			}
			else {
				artifactUri = link.uri;
				artifactOslcUri = link.oslcUri;
			}


			this._detailsView && this._detailsView.destroyRecursive();
			this._detailsView = new com.ibm.relm.ple.web.ui.internal.views.ArtifactView({
				partUri: itemVersion['pd:part'], //$NON-NLS-1$
				isDoorsBaseline: link.isDoorsBaseline,
				artifactUri: artifactUri,
				artifactOslcUri: artifactOslcUri,
				privateBaseline: link.privateBaseline,
				label: link.name,
				liveTitle: link.liveTitle,
				liveIcon: link.liveIcon
			});

			this._drawer.setDrawerContent(this._detailsView.domNode);
		},

		selectNothing: function()
		{
			window.location.href = '#' + dojo.objectToQuery({ action: 'ple.view_path' }); //$NON-NLS-1$ //$NON-NLS-2$
			this.clearDetailsPane();
			this._sidebar.deselectTrees();
			dojo.publish(jazz.ui.PageTemplate.StatusMessage.HIDE);
		},

		uninitialize: function()
		{
			this._detailsView.destroyRecursive();
			this._autoScrollHeight.destroy();
			this.inherited(arguments);
		}

	});
})();

